
function computeScore(x, y, ap, weapon, skills, stats, blocker, uselist){
	var score = 0; var maxda = 0, maxweap = false, map_p = false;
	var list = new Array(playerUnits[player].length);
	for(var i=0; i<playerUnits[player].length; i++){
		var u = playerUnits[player][i];
		if(u.health == 0) continue;
		var inrange = false;
		if(weapon.inRange(u.x, u.y, x, y)){
			inrange = true;
			if(weapon.apcost <= ap){
				var da = Math.min(u.health, weapon.getAvg(stats))/weapon.apcost/Math.sqrt(u.health);
				var kill_hits = Math.ceil(Math.max(1, u.health/(weapon.getAvg(stats))));
				if(kill_hits*weapon.apcost <= ap) da *= 10;
				if(da > maxda){maxda = da; maxweap = weapon; map_p = u;}
			}
		}
		for(var s=0; s<skills.length; s++)
			if(skills[s].skilltype == ATK_SKILL && skills[s].inRange(u.x, u.y, x, y)){
				inrange = true;
				if(skills[s].apcost <= ap){
					var da = Math.min(u.health, skills[s].getAvg(stats))/skills[s].apcost/Math.sqrt(u.health);
					var kill_hits = Math.ceil(Math.max(1, u.health/(skills[s].getAvg(stats))));
					if(kill_hits*skills[s].apcost <= ap) da *= 10;
					if(da > maxda){maxda = da; maxweap = skills[s]; map_p = u;}
				}
			}
		if(inrange) score += dist(x, y, u.x, u.y);
		else score -= PathfindLen(x, y, u.x, u.y, blocker)*7/Math.sqrt(u.health);
	}
	if(maxweap){
		var mod = 10000;
		uselist[0] = [maxweap, map_p];
		score += mod*0.1*maxda;
	}
	return score;
}

function healSkill(unit, skills, stats, m_rat, skilllist){
	var ratio = unit.health/unit.maxhealth;
	if(ratio >= m_rat) return;
	var maxha = 0, minskill;
	for(var i=0; i<skills.length; i++){
		if(!skills[i].baseHeal || unit.ap < skills[i].apcost) continue;
		var ha = skills[i].getAvg(stats)/skills[i].apcost;
		if(ha > maxha){maxha = ha; minskill = skills[i];}
	}
	if(minskill){
		if(unit.ap < minskill.apcost) return;
		unit.ap -= minskill.apcost;
		skilllist[skilllist.length] = function(){
			attack_weapon = minskill;
			if(attack_weapon.animation) attack_weapon.animation(unit.x, unit.y);
			attacker_stats = stats;
			attack_weapon.handleevent(unit);
		}
	}
}

function getUnitInRange(skill, x, y){
	for(var i=0; i<playerUnits[player].length; i++){
		var u = playerUnits[player][i];
		if(u.health == 0) continue;
		if(skill.inRange(u.x, u.y, x, y)) return u;
	}
	return false;
}

function shuffleAr(ar){
	for(var i=ar.length-1; i>=0; i--){
		var j = Math.floor(Math.random()*(i+1));
		var tmp = ar[i]; ar[i] = ar[j]; ar[j] = tmp;
	}
}

function useSkills(unit, skills, stats, skilllist){
	healSkill(unit, skills, stats, 0.5, skilllist);
	var arrand = new Array(skills.length); for(var c=0; c<skills.length; c++) arrand[c] = c; shuffleAr(arrand);
	var maxsv = 0, minskill;
	for(var idx=0; idx<skills.length; idx++){
		var i = arrand[idx];
		if(!skills[i].summonval || skills[i].apcost > unit.ap) continue;
		if(skills[i].summonval > maxsv){maxsv = skills[i].summonval; minskill = skills[i];}
	}
	if(minskill){
		var firstempty = false;
		minskill.forSpacesInRange(unit.x, unit.y, function(x, y){
			if(firstempty) return;
			if(y < 0 || y >= worldY || x < 0 || x >= worldX || worldGrid[y*worldX+x] != null || unit.ap < minskill.apcost) return;
			firstempty = true;
			unit.ap -= minskill.apcost;
			skilllist[skilllist.length] = function(){
				unit.ap += minskill.apcost;
				attack_weapon = minskill; attack_apcost = minskill.apcost;
				attacker_stats = stats;
				var tmp = selected; selected = unit;
				minskill.cast(x, y);
				selected = tmp;
			}
		});
	}
	for(var idx=0; idx<skills.length; idx++){
		var i = arrand[idx];
		if((!skills[i].baseUp && !skills[i].baseDown) || unit.ap < skills[i].apcost) continue;
		var selunitmod = unit;
		if(skills[i].baseDown){
			selunitmod = getUnitInRange(skills[i], unit.x, unit.y);
			if(selunitmod) unit.faceCell(selunitmod.x, selunitmod.y); else continue;
			var selstats = (selunitmod.member)?selunitmod.member.stats:((selunitmod.stats)?selunitmod.stats:[5,5,5,5,5,5]);
			if(selstats[skills[i].modstat] <= 2) continue;
		}
		var skill_id = i;
		unit.ap -= skills[skill_id].apcost;
		skilllist[skilllist.length] = function(){
			attack_weapon = skills[skill_id];
			if(attack_weapon.animation) attack_weapon.animation(selunitmod.x, selunitmod.y);
			attacker_stats = stats; attack_weapon.handleevent(selunitmod);
		}
	}
	var maxda = 0, minapskill;
	for(var i=0; i<skills.length; i++){
		if(!skills[i].apdamage || unit.ap < skills[i].apcost) continue;
		var da = skills[i].getAvg(stats)/skills[i].apcost;
		if(da > maxda){maxda = da; minapskill = skills[i];}
	}
	if(minapskill){
		var selunitapatk = getUnitInRange(minapskill, unit.x, unit.y);
		if(selunitapatk && selunitapatk.ap > 2){
			unit.ap -= attack_weapon.apcost;
			skilllist[skilllist.length] = function(){
				unit.faceCell(selunitapatk.x, selunitapatk.y);
				attack_weapon = minapskill;
				if(attack_weapon.animation) attack_weapon.animation(selunitapatk.x, selunitapatk.y);
				attacker_stats = stats;
				attack_weapon.handleevent(selunitapatk);
			}
		}
	}
	healSkill(unit, skills, stats, 0.8, skilllist);
}

function handleUnitAI(unit_id){
	if(unit_id >= playerUnits[AI].length){
		cur_player = (cur_player+1)%players.length;
		clearUIbar();
		startTurn();
		return;
	}
	var unit = playerUnits[AI][unit_id];
	computePaths(unit.x, unit.y, unit.range, unit.blocker);
	var weapon = (unit.weapon)?unit.weapon:barehanded;
	var skills = ((unit.skills)?unit.skills:new Array()), stats = ((unit.stats)?unit.stats:[5,5,5,5,5,5]);
	var maxscore = -1000000, maxx = unit.x, maxy = unit.y, maxr = 0, uselist = new Array(), skilllist = new Array();
	healSkill(unit, skills, stats, 0.3, skilllist);
	var idx = unit.y*worldX+unit.x; var tmp = worldGrid[idx]; worldGrid[idx] = null;
	for(var r=0; r<paths.length; r++){
		var ar = paths[r];
		for(var i=0; i<ar.length; i++){
			var list = new Array();
			var score = computeScore(ar[i][0], ar[i][1], unit.ap, weapon, skills, stats, unit.blocker, list);
			if(score > maxscore){
				maxscore = score; maxr = r;
				maxx = ar[i][0]; maxy = ar[i][1]; uselist = list;
			}
		}
	}
	worldGrid[idx] = tmp;
	var moreActions = (uselist.length > 0) | (maxx != unit.x || maxy != unit.y);
	var atkCt = 0, skillCt = 0;
	var doAttack = function(){
		animationCallback = false;
		if(atkCt >= Math.min(1,uselist.length)){
			if(skillCt == 0) useSkills(unit, skills, stats, skilllist);
			if(skillCt >= Math.min(1, skilllist.length)){
				if(moreActions | (skilllist.length > 0)) handleUnitAI(unit_id);
				else handleUnitAI(unit_id+1);
				return;
			}
			var func = skilllist[skillCt++];
			animationCallback = doAttack;
			func();
			return;
		}
		var atk = uselist[atkCt][1];
		attack_weapon = uselist[atkCt][0];
		atkCt++;
		if(atk.health <= 0 || unit.ap < attack_weapon.apcost){doAttack(); return;}
		unit.faceCell(atk.x, atk.y);
		unit.ap -= attack_weapon.apcost;
		animationCallback = doAttack;
		if(attack_weapon.animation) attack_weapon.animation(atk.x, atk.y);
		attacker_stats = stats;
		forEventsByPos(atk.x, atk.y, damageEvent);
	}
	if(maxx != unit.x || maxy != unit.y){
		unit.range -= maxr;
		doMoveAnim(unit, doAttack, maxx, maxy, maxr);
	} else doAttack();
}

//pathfinding

var paths = new Array();

function checkCell(i, x, y, blocker){
	if((x < 0) | (x >= worldX) | (y < 0) | (y >= worldY)) return;
	if(blocker == 1 && worldGrid[y*worldX+x] != null) return;
	for(var r=0; r<=i; r++){
		var ar = paths[r];
		for(var c=0; c<ar.length; c++)
			if((ar[c][0] == x) & (ar[c][1] == y)) return;
	}
	add(paths[i], [x, y]);
}

function computePaths(x, y, len, blocker){
	x = Math.floor(x); y = Math.floor(y);
	paths = new Array(len+1);
	paths[0] = [[x, y]];
	for(var i=0; i<len; i++){
		paths[i+1] = new Array();
		var ar = paths[i];
		for(var ct=0; ct<ar.length; ct++){
			var cx = ar[ct][0], cy = ar[ct][1];
			checkCell(i+1, cx-1, cy, blocker);
			checkCell(i+1, cx+1, cy, blocker);
			checkCell(i+1, cx, cy-1, blocker);
			checkCell(i+1, cx, cy+1, blocker);
		}
	}
}

function checkedlistContains(checkedlist, x, y){
	for(var i=0; i<checkedlist.length; i++){
		var c = checkedlist[i]; if((c[0] == x) & (c[1] == y)) return true;
	}
	return false;
}

function addCell(checkcells, checkedlist, spawn, x, y, tx, ty, blocker){
	if((x < 0) | (x >= worldX) | (y < 0) | (y >= worldY)) return;
	if(blocker == 1 && worldGrid[y*worldX+x] != null && (x != tx || y != ty)) return;
	if(checkedlistContains(checkedlist, x, y)) return;
	checkcells.insert(x, y, dist(x, y, tx, ty)+spawn.length-1, spawn);
}

function createNode(x, y, m_dist){
	var ret = new Object();
	ret.x = x; ret.y = y;
	ret.m_dist = m_dist;
	ret.isEmpty = function(){return this.m_dist == -1;}
	ret.removeFirst = function(){		
		if(this.left) return this.left.removeFirst();
		else {
			var spawn = new Object(); spawn.x = this.x; spawn.y = this.y; spawn.spawn = this.spawn;
			spawn.length = ((this.spawn)?this.spawn.length+1:1);
			if(this.right){
				this.x = this.right.x;
				this.y = this.right.y;
				this.m_dist = this.right.m_dist;
				this.spawn = this.right.spawn;
				this.left = this.right.left;
				this.right = this.right.right;
				if(this.left) this.left.parent = this;
				if(this.right) this.right.parent = this;
			} else if(this.parent){this.parent.left = null;}
			else this.m_dist = -1;
			return spawn;
		}
	};
	ret.insert = function(x, y, m_dist, spawn){
		if(this.m_dist == -1){this.x = x; this.y = y; this.m_dist = m_dist; this.spawn = spawn;}
		else if(m_dist <= this.m_dist){
			if(this.x == x && this.y == y){this.m_dist = Math.min(m_dist, this.m_dist);}
			if(this.left) this.left.insert(x, y, m_dist, spawn);
			else{this.left = createNode(x, y, m_dist); this.left.spawn = spawn; this.left.parent = this;}
		}
		else if(m_dist > this.m_dist){
			if(this.right) this.right.insert(x, y, m_dist, spawn);
			else{this.right = createNode(x, y, m_dist); this.right.spawn = spawn; this.right.parent = this;}
		}
	}
	return ret;
}

function Pathfind(x, y, tx, ty, blocker, movepath){
	astarPathfind(x, y, tx, ty, blocker, function(cell){
		var len = cell.length;
		movepath[len-1] = -1;
		for(var i=0; i<len-1; i++){
			var x1 = cell.x, y1 = cell.y;
			cell = cell.spawn;
			var x2 = cell.x, y2 = cell.y;
			movepath[len-i-2] = (x1 > x2)?2:(x1 < x2)?1:(y1 > y2)?3:0;
		}
	});
}

function PathfindLen(x, y, tx, ty, blocker){
	var path_len = worldX+worldY;
	astarPathfind(x, y, tx, ty, blocker, function(cell){
		path_len = cell.length;
	});
	return path_len;
}

function astarPathfind(x, y, tx, ty, blocker, ondone){
	x = Math.floor(x); y = Math.floor(y); tx = Math.floor(tx); ty = Math.floor(ty);
	var checkcells = createNode(x, y, dist(x, y, tx, ty));
	var checkedlist = new Array();
	while(!checkcells.isEmpty()){
		var cell = checkcells.removeFirst();
		if(checkedlistContains(checkedlist, cell.x, cell.y)) continue;
		if((cell.x == tx) & (cell.y == ty)){
			ondone(cell);
			return;
		}
		checkedlist[checkedlist.length] = [cell.x, cell.y];
		addCell(checkcells, checkedlist, cell, cell.x+1, cell.y, tx, ty, blocker);
		addCell(checkcells, checkedlist, cell, cell.x-1, cell.y, tx, ty, blocker);
		addCell(checkcells, checkedlist, cell, cell.x, cell.y+1, tx, ty, blocker);
		addCell(checkcells, checkedlist, cell, cell.x, cell.y-1, tx, ty, blocker);
	}
}