var global, party, inventory;

var NONE = -1, LOCAL = 0, AI = 1;
var players = [NONE, AI, LOCAL];
var playerNames = ['None', 'Computer', 'Player'];
var playerColors = ['666666', 'cc2c00', '0066cc'];
var playerUnits = new Array(players.length);
var none = 0, player = 2;

function resetGlobal(){
	global = new Object(); party = new Array();
	inventory = new Object();
	inventory.gold = 0; inventory.items = new Array();
}

resetGlobal();

function copyAr(ar){
	var ret = new Array(ar.length);
	for(var i=0; i<ar.length; i++) ret[i] = ar[i];
	return ret;
}

function zeroArray(len){
	var ret = new Array(len);
	for(var i=0; i<len; i++) ret[i] = 0;
	return ret;
}

function getArStr(ar){
	var str = "[";
	for(var i=0; i<ar.length; i++){
		if(i != 0) str += ",";
		var val = ar[i];
		var type = typeof(val);
		if(type == 'object') if(val.getReference) val = val.getReference(); else val = false;
		if(type == 'string') val = "\""+val+"\"";
		str += val;
	}
	return str+"]";
}

function findItem(item){
	var str = item.getReference();
	for(var i=0; i<inventory.items.length; i++)
		if(inventory.items[i].item.getReference() == str) return i;
	return -1;
}

function addItem(item){
	var i = findItem(item);
	if(i == -1){
		var o = new Object(); o.item = item; o.count = 1;
		inventory.items[inventory.items.length] = o;
	} else inventory.items[i].count++;
	if(invShow) showInventory();
}

function addItems(item, ct){
	var i = findItem(item);
	if(i == -1){
		var o = new Object(); o.item = item; o.count = ct;
		inventory.items[inventory.items.length] = o;
	} else inventory.items[i].count += ct;
	if(invShow) showInventory();
}

function removeItem(item){
	var i = findItem(item);
	if(i == -1) return;
	inventory.items[i].count--;
	if(inventory.items[i].count == 0) arRemove(inventory.items, inventory.items[i]);
	if(invShow) showInventory();
}
function removeItems(i, ct){
	inventory.items[i].count -= ct;
	if(inventory.items[i].count <= 0) arRemove(inventory.items, inventory.items[i]);
	if(invShow) showInventory();
}
function getItem(i){return inventory.items[i].item;}

var DEF_LIGHT=0, DEF_MEDIUM=1, DEF_HEAVY=2, DEF_FIRE=3, DEF_WATER=4, DEF_EARTH=5, DEF_AIR=6, DEF_GHOST=7, DEF_UNDEAD=8, DEF_HOLY=9, DEF_EVIL=10;
var ATK_BLUNT=0, ATK_SLASH=1, ATK_PIERCE=2, ATK_FIRE=3, ATK_WATER=4, ATK_EARTH=5, ATK_AIR=6, ATK_MAGIC=7, ATK_HOLY=8, ATK_EVIL=9;

var WEAPON = 0, SHIELD = 1, ARMOR = 2, HELM = 3, OTHER = 4, NUM_EQUIP = 5;
var equipNames = ["Weapon", "Shield", "Armor", "Helm", "Other"];
var equipAP = 10, useAP = 5;
var VITALITY=0, DEXTERITY=1, AGILITY=2, MELEE=3, RANGED=4, WISDOM=5;
var statNames = ["V","D","A","M","R","W"];

function equip(item, e){
	if(menuScreen != EQUIPMENT) return;
	var i = getMenuSelected();
	if(i != -1){
		if(e == SHIELD && party[i].get(WEAPON) && !party[i].get(WEAPON).onehanded) unequip(i, WEAPON);
		if(e == WEAPON && !item.onehanded) unequip(i, SHIELD);
		if(inBattle){
			if(party[i].unit.ap < equipAP){showUIStatus("Not Enough AP to Equip "+equipNames[e]+"."); return;}
			party[i].unit.ap -= equipAP;
		}
		if(party[i].get(e)){var tmp = party[i].get(e); if(tmp.unequip) tmp.unequip(party[i]); addItem(tmp);}
		party[i].equipment[e] = item;
		if((e == ARMOR) & party[i].unit) party[i].unit.attribute = item.attribute;
		if(item.equip) item.equip(party[i]);
		removeItem(item);
		refreshMenu();
	}
}

function unequip(i, e){
	if(!party[i].get(e)) return;
	if(inBattle){
		if(party[i].unit.ap < equipAP){showUIStatus("Not Enough AP to Unequip "+equipNames[e]+"."); return;}
		party[i].unit.ap -= equipAP;
	}
	var item = party[i].get(e);
	addItem(item);
	party[i].equipment[e] = false;
	if(item.unequip) item.unequip(party[i]);
	if((e == ARMOR) & party[i].unit) party[i].unit.attribute = DEF_LIGHT;
	refreshMenu();
}

function addPartyMember(member){member.id = party.length; party[party.length] = member;}

function damageStr(w, stats){return w.getMin(stats)+"-"+w.getMax(stats)+" ("+w.getAvg(stats)+" Avg"+((w.critical > 0)?"; "+Math.floor(w.critical*100)+"% Crit":"")+")";}

function isGuide(m){return (parseInt(m.img.substring(0, 3)) >= 151);}

function createPartyMember(uname, img, x, y, dir, stats){
	var member = new Object();
	member.name = uname; member.img = img; member.x = x; member.y = y; member.unit = null; member.facing = dir;
	member.equipment = new Array(NUM_EQUIP); member.skills = new Array();
	member.equipment[ARMOR] = item_db[0];
	member.level = 1; member.exp = 0; member.stats = copyAr(stats);
	member.health = getCharacterHP(stats[0]); member.maxhealth = member.health; member.ap = getCharacterAP(stats[1]);
	member.maxap = member.ap; member.range = getCharacterRange(stats[2]);
	member.get = function(i){return this.equipment[i];};
	member.loadUnit = function(){
		if(this.health <= 0) return null;
		var unit = spawnUnit(player, this.name, this.img, this.x, this.y, this.stats);
		unit.health = this.health; unit.ap = this.ap; unit.facing = this.facing;
		unit.member = this; unit.level = this.level;
		this.unit = unit; var a = this.get(ARMOR); unit.attribute = (a)?a.attribute:DEF_LIGHT;
		return unit;
	};
	member.update = function(){
		if(!this.unit) return;
		this.name = this.unit.name; this.img = this.unit.sprite; this.x = this.unit.x; this.y = this.unit.y; this.facing = this.unit.facing;
		this.health = this.unit.health; this.ap = this.unit.ap;
	};
	member.getAC = function(){var a = this.get(ARMOR); return getDefAttrName((a)?a.attribute:DEF_LIGHT);}
	member.getAtkAP = function(){var w = this.get(WEAPON); return (w)?w.apcost:barehanded.apcost;}
	member.getDamageStr = function(){
		var w = this.get(WEAPON);
		if(!w) w = barehanded;
		return damageStr(w, this.stats);
	}
	member.levelUp = function(){
		var v = Math.pow(0.9, this.level);
		for(var i=0; i<this.stats.length; i++)
			this.stats[i] += this.stats[i]*0.3*v;
		this.maxhealth = getCharacterHP(this.stats[0]); this.maxap = getCharacterAP(this.stats[1]);
		this.range = getCharacterRange(this.stats[2]);
		if(this.unit){
			this.unit.maxhealth = this.maxhealth; this.unit.maxap = this.maxap; this.unit.maxrange = this.range;
			this.unit.level = this.level+1;
		}
		this.level++;
	}
	member.updateUnit = function(){
		if(!this.unit) return;
		this.unit.name = this.name; this.unit.sprite = this.img;
		this.unit.health = this.health; this.unit.maxhealth = this.maxhealth; this.unit.ap = this.ap; this.unit.maxap = this.maxap;
	}
	member.updateStats = function(){
		this.maxhealth = getCharacterHP(this.stats[0]); this.maxap = getCharacterAP(this.stats[1]);
		this.range = getCharacterRange(this.stats[2]); this.health = Math.min(this.health, this.maxhealth);
		this.ap = Math.min(this.ap, this.maxap);
		if(this.unit){
			this.unit.maxhealth = this.maxhealth; this.unit.maxap = this.maxap; this.unit.maxrange = this.range;
			this.unit.health = Math.min(this.unit.health, this.unit.maxhealth); this.unit.ap = Math.min(this.unit.ap, this.unit.maxap);
			this.unit.range = Math.min(this.unit.range, this.unit.maxrange);
		}
	}
	member.addSkill = function(skill){
		for(var i=0; i<this.skills.length; i++) if(this.skills[i] == skill) return;
		this.skills[this.skills.length] = skill;
	}
	return member;
}

function showParty(callback, pid){
	var punit = getPlayerUnit();
	if(!pid){pid = 1; computePaths(punit.x, punit.y, 6, true); pauseGame();}
	if(pid >= party.length){
		var punit = getPlayerUnit();
		worldGrid[getY(punit)*worldX+getX(punit)] = punit;
		resumeGame();
		if(callback) callback();
		return;
	}
	if((party[pid].unit != null) | (party[pid].health == 0)){
		showParty(callback, pid+1);
		return;
	}
	party[pid].x = punit.x; party[pid].y = punit.y;
	var newunit = party[pid].loadUnit();
	var getPath = function(){
	for(var r=1; r<paths.length; r++){
		for(var i=0; i<paths[r].length; i++){
			var g = worldGrid[paths[r][i][1]*worldX+paths[r][i][0]];
			if(!g || !g.member){
				doMoveAnim(newunit, function(){
					newunit.setDir(punit.facing);
					showParty(callback, pid+1);
				}, paths[r][i][0], paths[r][i][1], r);
				return true;
			}
		}
	}
	return false;
	};
	if(!getPath()){
		computePaths(punit.x, punit.y, 6, false);
		getPath();
	}
}

function hideParty(callback, pid){
	if(!pid){
		pid = 1;
		pauseGame();
		var punit = getPlayerUnit();
		worldGrid[getY(punit)*worldX+getX(punit)] = null;
	}
	if(pid >= party.length){
		var punit = getPlayerUnit();
		worldGrid[getY(punit)*worldX+getX(punit)] = punit;
		resumeGame();
		if(callback) callback();
		return;
	}
	if((party[pid].unit == null) | (party[pid].health == 0)){
		hideParty(callback, pid+1);
		return;
	}
	var punit = getPlayerUnit();
	var newunit = party[pid].unit;
	moveToAnim(newunit, function(){
		removeEvent(newunit); party[pid].unit = null;
		hideParty(callback, pid+1);
	}, punit.x, punit.y);
}

function getPlayerUnit(){
	return party[0].unit;
}

function updatePartyMembers(){
	for(var i=0; i<party.length; i++) party[i].update();
}

function nullPartyMembers(){
	for(var i=0; i<party.length; i++) party[i].unit = null;
}

function getReference(item){
	if(item) return item.getReference();
	else return "false";
}

function savePartyMember(member){
	return "['"+member.name+"','"+member.img+"',"+member.x+","+member.y+","+member.facing+","+member.health+","+member.ap+","+member.exp+","+member.level+","+getArStr(member.stats)+","+getArStr(member.equipment)+","+getArStr(member.skills)+"]";
}

function loadPartyMember(ar){
	var member = createPartyMember(ar[0], ar[1], ar[2], ar[3], ar[4], ar[9]);
	member.health = ar[5]; member.ap = ar[6]; member.exp = ar[7]; member.level = ar[8];
	member.equipment = ar[10]; member.skills = ar[11];
	addPartyMember(member);
	return member;
}

function getSavedGames(func){
	var ret = new Array();
	var cookiesaves = document.cookie.split("; ");
	var token = escape("sgs=true;");
	for(var i=0; i<cookiesaves.length; i++){
		var text = cookiesaves[i];
		var index = text.indexOf("=");
		if(index == -1 || text.indexOf(token) == -1) continue;
		ret[ret.length] = text.substring(0, index);
	}
	return ret;
}

function continueGame(){
	uibar.style.visibility = 'hidden';
	gameMenu.style.visibility = 'visible';
	menuBox.style.width = '400px';
	var htmltext = "<b>Saved Games:</b><div style='width: 380px; height:260px; overflow:auto;'>";
	var saves = getSavedGames();
	for(var i=0; i<saves.length; i++){
		if(i != 0) htmltext += "<br>";
		htmltext += "<a href=\"javascript:loadSave('"+saves[i]+"');\">"+saves[i]+"</a>&nbsp;&nbsp;<a href=\"javascript:deleteSave('"+saves[i]+"');\">[x]</a>";
	}
	if(saves.length == 0) htmltext += "<i>No Saved Games.</i>";
	htmltext += "</div><a href='javascript:displayTitle();'>&lt; Back</a>";
	menuBox.innerHTML = htmltext;
}

function deleteSave(name){
	if(confirm("Are you sure you wish to delete the saved game: "+name+"?")){
		setCookie(name, "", new Date());
		continueGame();
	}
}

function overwriteSave(name){
	if(confirm("Are you sure you wish to overwrite the saved game: "+name+"?")) saveGame(name);
}

function saveGame(name){
	if(inBattle || name == "" || name == "gameOptions") return;
	updatePartyMembers();
	var text = "sgs=true;m='"+mapName+"';g=[";
	var first = true;
	for(key in global){
		var val = global[key];
		if(val == null) continue;
		var type = typeof(val);
		if(type != 'boolean' && type != 'number' && type != 'string' && type != 'object') continue;
		if(type == 'object') if(val.getReference) val = val.getReference(); else continue;
		if(type == 'string') val = "\""+val+"\"";
		if(first) first = false; else text += ",";
		text+="['"+key+"',"+val+"]";
	}
	text += "];p=[";
	first = true;
	for(var i=0; i<party.length; i++){
		if(first) first = false; else text += ",";
		text+=savePartyMember(party[i]);
	}
	text += "];i=["+inventory.gold;
	for(var i=0; i<inventory.items.length; i++){
		text += ","+inventory.items[i].count+",";
		text += inventory.items[i].item.getReference();
	}
	text += "];l=[";
	first = true;
	for(var i=0; i<mapEvents.length; i++){
		var vars = mapEvents[i][1].vars;
		var tmp = "";
		var noelem = true;
		for(key in vars){
			var val = vars[key];
			if(val == null) continue;
			var type = typeof(val);
			if(type != 'boolean' && type != 'number' && type != 'string' && type != 'object') continue;
			if(type == 'object') if(val.getReference) val = val.getReference(); else continue;
			if(type == 'string') val = "\""+val+"\"";
			if(noelem) noelem = false; else tmp += ",";
			tmp+="['"+key+"',"+val+"]";
		}
		if(!noelem){
			if(first) first = false; else text += ",";
			text += "["+i+",["+tmp+"]]";
		}
	}
	text += "];";
	setCookie(name, text);
	showPartyPanel();
}

function loadSave(name){
	var save = getCookie(name);
	if(save == null) return;
	var sgs = false, m = false, g = false, p = false, i = false, l = false;
	resetGlobal();
	try{eval(save);}catch(e){error("Corrupt Save File."); return;}
	if(!sgs | !m | !g | !p | !i | !l){error("Corrupt Save File."); return;}
	for(var c=0; c<g.length; c++) global[g[c][0]] = g[c][1];
	for(var c=0; c<p.length; c++){party[c] = loadPartyMember(p[c]);}
	inventory.gold = i[0];
	for(var c=1; c<i.length; c+=2){
		var o = new Object(); o.item = i[c+1]; o.count = i[c];
		inventory.items[inventory.items.length] = o;
	}
	closeTitle();
	loadMap(m, undefined, undefined, function(){
		for(var c=0; c<l.length; c++){
			var event = mapEvents[l[c][0]][1];
			var vars = l[c][1];
			for(var j=0; j<vars.length; j++)
				event.vars[vars[j][0]] = vars[j][1];
		}
	});
}

var selitem = false;
function selectItem(item){
	if(selitem) selitem.style.backgroundImage = "";
	selitem = item;
	selitem.style.backgroundImage = "url('images/iconsel.gif')";
}

var invShow = false;

function showInventory(){
	invShow = true;
	var text = "<table width=100% height=100% cellpadding=0 cellspacing=0><tr><td><div style='position:relative; width:540px; height:100%; overflow-x:scroll; overflow-y:hidden;'>";
	for(var i=0; i<inventory.items.length; i++){
		var item = inventory.items[i].item;
		text += "<div style='position:absolute; top:0px; left:"+(i*24)+"px'>";
		text += getIcon(item.icon);
		if(inventory.items[i].count > 1) text += "<div style='position:absolute; bottom:0px; right:0px; font-weight:bold; font-size:12px;'>x"+inventory.items[i].count+"</div>";
		var alt = item.name+": "+item.description;
		text += "<img style='position:absolute; top:0px; left:0px; cursor:pointer;' src='images/blank.gif' itemid='"+i+"' onclick='selectItem(this);' ondblclick='useItem(getItem("+i+"));' alt=\""+alt+"\" title=\""+alt+"\" width=24 height=24 />";
		text += "</div>";
	}
	text += "</div></td><td><a href='javascript:closeInventory();'>(close)</a>&nbsp;&nbsp;<a href='javascript:showMenu();'>Menu</a></td></tr></table>";
	uibar.innerHTML = text;
}

var skillBarSkills;

function showSkillBar(){
	if(gamePaused()) return;
	var skills = (selected.member)?selected.member.skills:(selected.skills)?selected.skills:[];
	invShow = false;
	skillBarSkills = skills;
	var text = "<table width=100% height=100% cellpadding=0 cellspacing=0><tr><td><div style='position:relative; width:540px; height:100%; overflow-x:scroll; overflow-y:hidden;'>";
	for(var i=0; i<skills.length; i++){
		text += "<div style='position:absolute; top:0px; left:"+(i*24)+"px'>";
		text += getIcon(skills[i].icon);
		var alt = skills[i].name+": "+skills[i].description;
		text += "<img style='position:absolute; top:0px; left:0px; cursor:pointer;' src='images/blank.gif' onclick='castSkill(skillBarSkills["+i+"]);' alt=\""+alt+"\" title=\""+alt+"\" width=24 height=24 />";
		text += "</div>";
	}
	text += "</div></td><td><a href='javascript:closeInventory();'>(close)</a>&nbsp;&nbsp;<a href='javascript:showMenu();'>Menu</a></td></tr></table>";
	uibar.innerHTML = text;
}

var char_class, char_gender, char_points, char_stats, char_callback;

function getCharacterHP(v){return Math.floor(120*Math.pow(v/20, 1.2)+0.5);}
function getCharacterAP(d){return Math.floor(20*Math.pow(d/20, 0.4)+0.5);}
function getCharacterRange(a){return Math.floor(5*Math.pow(a/20, 0.3)+0.5);}
function nextLevelEXP(l){return (l <= 0)?0:Math.floor(50*(l+Math.pow((l-1), 2))+0.5);}

function updateBaseStats(){
	document.getElementById('charHP').innerHTML = getCharacterHP(char_stats[0]);
	document.getElementById('charAP').innerHTML = getCharacterAP(char_stats[1]);
	document.getElementById('charRange').innerHTML = getCharacterRange(char_stats[2]);
}

function prevClass(){char_class--; if(char_class < 0) char_class = class_names.length-1; changeClass(char_class);}
function nextClass(){char_class = (char_class+1)%(class_names.length); changeClass(char_class);}

function changeClass(c){
	char_class = c;
	document.getElementById('characterImg').style.backgroundImage = "url('images/Characters/"+class_sprites[char_class][char_gender]+"')";
	var stats = class_stats[char_class];
	char_points = CHAR_EXTRA_POINTS;
	document.getElementById('charPoints').innerHTML = char_points;
	document.getElementById('charClassName').innerHTML = class_names[char_class];
	for(var i=0; i<stats.length; i++){
		char_stats[i] = stats[i];
		document.getElementById('char_stat'+i).innerHTML = char_stats[i]+"&nbsp;<a href='javascript:increaseStat("+i+")'>[+]</a>&nbsp;[-]";
	}
	updateBaseStats();
}

function changeGender(g){
	char_gender = g;
	document.getElementById('charGender'+g).style.color = 'black';
	document.getElementById('charGender'+g).style.cursor = 'default';
	g = (g+1)%2;
	document.getElementById('charGender'+g).style.color = 'blue';
	document.getElementById('charGender'+g).style.cursor = 'pointer';
	document.getElementById('characterImg').style.backgroundImage = "url('images/Characters/"+class_sprites[char_class][char_gender]+"')";
}

function createChar(){
	var name = document.getElementById('characterName').value;
	if(name == ''){alert('Your Character Needs a Name.'); return;}
	if(char_points > 0 && !confirm("You have unused points left. Continue anyway?")) return;
	var char = createPartyMember(name, class_sprites[char_class][char_gender], 0, 0, 0, char_stats);
	global.char_class = char_class;
	closeTitle();
	if(char_callback) char_callback(char);
}

function increaseStat(i){
	if(char_points <= 0) return;
	char_points--;
	char_stats[i]++;
	document.getElementById('char_stat'+i).innerHTML = char_stats[i]+"&nbsp;<a href='javascript:increaseStat("+i+")'>[+]</a>&nbsp;<a href='javascript:decreaseStat("+i+")'>[-]</a>";
	document.getElementById('charPoints').innerHTML = char_points;
	if(char_points == 0)
		for(var i=0; i<char_stats.length; i++)
			document.getElementById('char_stat'+i).innerHTML = char_stats[i]+"&nbsp;[+]&nbsp;"+((char_stats[i] <= class_stats[char_class][i])?"[-]":"<a href='javascript:decreaseStat("+i+")'>[-]</a>");
	updateBaseStats();
}

function decreaseStat(i){
	if((char_points >= CHAR_EXTRA_POINTS) | (char_stats[i] <= class_stats[char_class][i])) return;
	char_points++;
	char_stats[i]--;
	document.getElementById('char_stat'+i).innerHTML = char_stats[i]+"&nbsp;<a href='javascript:increaseStat("+i+")'>[+]</a>&nbsp;"+((char_stats[i] <= class_stats[char_class][i])?"[-]":"<a href='javascript:decreaseStat("+i+")'>[-]</a>");
	document.getElementById('charPoints').innerHTML = char_points;
	if(char_points == 1)
		for(var i=0; i<char_stats.length; i++)
			document.getElementById('char_stat'+i).innerHTML = char_stats[i]+"&nbsp;<a href='javascript:increaseStat("+i+")'>[+]</a>&nbsp;"+((char_stats[i] <= class_stats[char_class][i])?"[-]":"<a href='javascript:decreaseStat("+i+")'>[-]</a>");
	updateBaseStats();
}

function createCharacter(callback){
	uibar.style.visibility = 'hidden';
	gameMenu.style.visibility = 'visible';
	menuBox.style.width = '400px';
	char_callback = callback; char_class = 0; char_gender = 0; char_points = CHAR_EXTRA_POINTS; char_stats = new Array();
	var text = "<b>Create Your Character:</b><br><br><table width=100% border=1><tr><td colspan=2><b>Name:</b> <input id='characterName' type='text' size=20 onfocus='textareafocused=true;' onblur='textareafocused=false;'></td></tr><tr><td width=40% align=center>";
	text += "<div class='unitView' id='characterImg' style=\"background-image:url('images/Characters/"+class_sprites[char_class][char_gender]+"');\"></div>";
	text += "<br><a href='javascript:prevClass()'>&lt;&lt;</a>&nbsp;&nbsp;<div id='charClassName' style='display:inline; font-weight:bold;'>"+class_names[char_class]+"</div>&nbsp;&nbsp;<a href='javascript:nextClass()'>&gt;&gt;</a>";
	text += "<br><a href='javascript:changeGender(0);' id='charGender0' style='color:black; cursor:default;'>[Male]</a>&nbsp;&nbsp<a href='javascript:changeGender(1);' id='charGender1' style='color:blue;'>[Female]</a>";
	text += "</td><td width=60%><table border=1 width=100% class='charCreateStats'><tr><td colspan=2>";
	text += "<table width=100%><tr><td><b>Health:</b> <div style='display:inline;' id='charHP'>0</div></td><td><b>AP:</b> <div style='display:inline;' id='charAP'>0</div></td><td><b>Range:</b> <div style='display:inline;' id='charRange'>0</div></td></tr></table></td></tr>";
	text += "<tr><td><b>Vitality:</b> <div style='display:inline;' id='char_stat0'>0</div></td><td><b>Dexterity:</b> <div style='display:inline;' id='char_stat1'>0</div></td></tr>";
	text += "<tr><td><b>Agility:</b> <div style='display:inline;' id='char_stat2'>0</div></td><td><b>Melee:</b> <div style='display:inline;' id='char_stat3'>0</div></td></tr>";
	text += "<tr><td><b>Ranged:</b> <div style='display:inline;' id='char_stat4'>0</div></td><td><b>Wisdom:</b> <div style='display:inline;' id='char_stat5'>0</div></td></tr>";
	text += "<tr><td colspan=2 align=center><b>Points Left:</b> <div style='display:inline;' id='charPoints'>"+char_points+"</div></td></tr></table>";
	text += "</td></tr></table><a href='javascript:displayTitle();'>&lt; Back</a>&nbsp;&nbsp;&nbsp;&nbsp;<a href='javascript:createChar();'>Create &gt;</a>";
	menuBox.innerHTML = text;
	changeClass(char_class);
}