
var GOLD_ICON = 205;

var item_db = new Array();
function registerItem(item){
	var id = item_db.length;
	item_db[id] = item;
	item.getReference = function(){return "item_db["+id+"]";};
	add(marketItems[item.market], item);
	return item;
}

var other_db = new Array();
function registerOther(item){
	var id = other_db.length;
	other_db[id] = item;
	item.getReference = function(){return "other_db["+id+"]";};
	return item;
}

function createKey(key_img, keyid, name, descr){
	var key = new Object();
	key.name = name;
	key.getReference = function(){return "createKey("+key_img+","+keyid+",\""+name+"\",\""+descr+"\")";};
	key.keyid = keyid;
	key.icon = key_img+80;
	key.description = descr;
	key.market = CHEAP_ITEM_MARKET;
	key.cost = 2;
	return key;
}

function createPurse(gold, name){
	var purse = new Object();
	if(name) purse.name = name; else purse.name = "Bag 'O Gold";
	purse.getReference = function(){return "createPurse("+gold+((name)?",\""+name+"\"":"")+")";};
	purse.use = function(){playSE("audio/sound/Item2.wav"); inventory.gold += gold; removeItem(this); if(!menuOpen) showDialog("Removed "+gold+" gold from the bag.", "middle"); return true;}
	purse.icon = 144;
	purse.description = "A bag containing "+gold+" gold coins.";
	purse.market = FINE_ITEM_MARKET;
	purse.cost = gold;
	return purse;
}

function createArmor(img, name, descr, attr, cost, agldown){
	var armor = new Object();
	armor.name = name; armor.getReference = function(){return "createArmor("+img+",\""+name+"\",\""+descr+"\","+attr+","+cost+((agldown)?","+agldown:"")+")";};
	armor.icon = img;
	armor.description = descr;
	armor.market = (cost >= 1000)?FINE_ARMOR_MARKET:CHEAP_ARMOR_MARKET;
	armor.cost = cost;
	armor.attribute = attr; 
	armor.use = function(){equip(this, ARMOR); return true;}
	if(agldown){
		armor.equip = function(u){u.stats[AGILITY] -= agldown; u.stats[DEXTERITY] -= agldown; u.updateStats();}
		armor.unequip = function(u){u.stats[AGILITY] += agldown; u.stats[DEXTERITY] += agldown; u.updateStats();}
	}
	return armor;
}

function setDefense(armor, vitup, agldown){
	armor.equip = function(u){u.stats[VITALITY] += vitup; u.stats[AGILITY] -= agldown; u.stats[DEXTERITY] -= agldown; u.updateStats();}
	armor.unequip = function(u){u.stats[VITALITY] -= vitup; u.stats[AGILITY] += agldown; u.stats[DEXTERITY] += agldown; u.updateStats();}
	return armor;
}

function incrStat(armor, modstat, modval){
	armor.equip = function(u){u.stats[modstat] += modval; u.updateStats();}
	armor.unequip = function(u){u.stats[modstat] -= modval; u.updateStats();}
	return armor;
}

function incrAllStats(armor, modval){
	armor.equip = function(u){for(var i=0; i<u.stats.length; i++) u.stats[i] += modval; u.updateStats();}
	armor.unequip = function(u){for(var i=0; i<u.stats.length; i++) u.stats[i] -= modval; u.updateStats();}
	return armor;
}

function createEquipment(img, name, descr, slot, cost){
	var armor = new Object();
	armor.name = name; armor.getReference = function(){return "createEquipment("+img+",\""+name+"\",\""+descr+"\","+slot+","+cost+")";};
	armor.icon = img;
	armor.description = descr;
	armor.market = (cost >= 1000)?FINE_ARMOR_MARKET:CHEAP_ARMOR_MARKET;
	armor.cost = cost; armor.slot = slot;
	armor.use = function(){equip(this, this.slot); return true;}
	return armor;
}

function createBook(skill, cost){
	var book = new Object();
	if(!cost) cost = Math.ceil(Math.pow(skill.complexity, 2)*0.12345679);
	book.name = skill.name+" for "+((cost >= 1000)?"Smarties":"Dummies"); book.getReference = function(){return "createBook("+skill.getReference()+","+cost+")";};
	book.icon = (skill.skilltype == ATK_SKILL)?176:177;
	book.description = "Teaches the skill "+skill.name+".";
	book.market = (cost >= 1000)?FINE_MAGIC_MARKET:CHEAP_MAGIC_MARKET;
	book.cost = cost; book.skill = skill;
	book.use = function(){
		var i = getMenuSelected();
		if(i != -1){
			playSE("audio/sound/night.wav");
			party[i].addSkill(this.skill);
		}
		return true;
	}
	return book;
}

function createScroll(img, name, descr, skill, cost){
	var scroll = new Object();
	scroll.name = name; scroll.getReference = function(){return "createScroll("+img+",\""+name+"\",\""+descr+"\","+skill.getReference()+","+cost+")";};
	scroll.icon = img;
	scroll.description = descr;
	scroll.market = (cost >= 1000)?FINE_ITEM_MARKET:CHEAP_ITEM_MARKET;
	scroll.cost = cost; scroll.skill = skill;
	scroll.use = function(){castScroll(this); attack_item = this; return false;}
	return scroll;
}

function createSpellScroll(skill){
	var cost = Math.ceil(Math.pow(skill.complexity, 1.8)*0.0348794383);
	var scroll = createScroll(150, skill.name+" Scroll", "Casts "+skill.name+".", skill, cost);
	scroll.market = (cost >= 100)?FINE_MAGIC_MARKET:CHEAP_MAGIC_MARKET;
	return scroll;
}

function createTownPortal(name, descr, map, x, y, cost){
	var portal = new Object();
	portal.name = name; portal.description = descr; portal.cost = cost; portal.getReference = function(){return "createTownPortal(\""+name+"\",\""+descr+"\",\""+map+"\","+x+","+y+","+cost+")";};
	portal.icon = 150;
	portal.market = (portal.cost >= 1000)?FINE_MAGIC_MARKET:CHEAP_MAGIC_MARKET;
	portal.use = function(){
		if(inBattle){showUIStatus("You cannot use "+this.name+" in battle."); return false;}
		var unit = getPlayerUnit();
		unit.keepAlive = true;
		animationCallback = function(){animationCallback = false; unit.keepAlive = false; loadMap(map, x, y); removeItem(portal);}
		portalAnim(unit.x, unit.y);
		unit.fadeAnim();
		return false;
	}
	return portal;
}

function createMiscItem(img, name, descr, cost){
	var misc = new Object();
	misc.name = name; misc.description = descr;
	misc.getReference = function(){return "createMiscItem("+img+",\""+name+"\",\""+descr+"\","+cost+")";};
	misc.icon = img;
	misc.market = (cost >= 1000)?FINE_ITEM_MARKET:CHEAP_ITEM_MARKET;
	misc.cost = cost;
	return misc;
}

var iconDim = 16;

function getIcon(icon, func){
	var xpos = -(icon%iconDim)*24, ypos = -Math.floor(icon/iconDim)*24;
	return "<img class='itemicon' style='background-position:"+xpos+'px '+ypos+"px;"+((func)?" cursor:pointer;' onclick='"+func+";'":"'")+" src='images/blank.gif' width=24 height=24 /></img>";
}