var worldTileset, worldAutoTiles, worldAnim, worldTiles, blockedTiles, mapEvents, mapExists = false, viewBlocking = false, mapName;

var nlayers = 7;

var scriptLoading = false;

function recoverMap(map_src){
	map_src = map_src.toLowerCase();
	mapName = map_src;
	map_src = "maps/"+map_src+".js";
	scriptLoading = true;
	mapExists = false;
	var mapDiv = document.getElementById('mapdiv');
	while(mapDiv.hasChildNodes()) mapDiv.removeChild(mapDiv.firstChild);
	var script = document.createElement('script');
	script.type = 'text/javascript';
	script.onreadystatechange = function(){if(this.readyState == 'complete' || this.readyState == 'loaded') finishLoadMap();}
	script.onload = finishLoadMap;
	script.src = map_src;
	mapDiv.appendChild(script);
}

function skipToTile(idx){
	for(var i=idx; i<worldTiles.length; i++){
		if(worldTiles[i][3]%TILE_SIZE == 0 && worldTiles[i][4]%TILE_SIZE == 0) return i;
	}
	return worldTiles.length;
}

function finishLoadMap(){
	if(!scriptLoading) return;
	scriptLoading = false;
	if(!mapExists) return;
	var text = "worldName.value='"+mapName+"';document.getElementById('leftView').src='http://localhost/viewer.html?right';document.getElementById('rightView').src='http://localhost/viewer.html?left';document.getElementById('topView').src='http://localhost/viewer.html?bottom';document.getElementById('bottomView').src='http://localhost/viewer.html?top';tileset='"+worldTileset+"';";
	text += "autotile = [";
	for(var n=0; n<8; n++){
		if(n > 0) text += ",";
		text += "'"+worldAutoTiles[n]+"'";
	}
	text += "];";
	text += "tileanims = [";
	for(var n=0; n<8; n++){
		if(n > 0) text += ",";
		text += worldAnim[n];
	}
	text += "];";
	text += "map=[";
	["+getBPosAr(obj.style.backgroundPosition)+","+getClassIdx(obj.className)+","+obottom+","+oleft+","+getLayerNum(name)+"]
	var idx = skipToTile(0);
	for(var l=0; l<nlayers-1; l++){
		if(l != 0) text += ",";
		text += "[";
		for(var y=0; y<worldY; y++)
			for(var x=0; x < worldX; x++){
				if(y+x != 0 ) text += ",";
				if(idx < worldTiles.length && x*TILE_SIZE == worldTiles[idx][4] && y*TILE_SIZE == worldTiles[idx][3]){
					if(worldTiles[idx][2] == -1) text += "['"+worldTiles[idx][0]+"px "+worldTiles[idx][1]+"px','tile tilemap']";
					else text += "['32px 32px','auto tile n"+(worldTiles[idx][2]%8)+"']";
					idx = skipToTile(idx+1);
				}
				else{if(l==0) text += "['','tile tilemap']"; else text += "['32px 32px','tile tilemap']";}
			}
		text += "]";
	}
	text += ",[";
	idx = 0;
	for(var y=0; y<worldY; y++)
		for(var x=0; x < worldX; x++){
			if(y+x != 0 ) text += ",";
			if(idx < mapEvents.length && x*TILE_SIZE == mapEvents[idx][2] && y*TILE_SIZE == mapEvents[idx][1]){
				text += "['"+mapEvents[idx][0][0]+"','"+mapEvents[idx][0][1]+"','"+mapEvents[idx][0][2]+"'";
				for(var i=3; i<16; i++) text += ","+mapEvents[idx][0][i];
				text += "]";
				idx++;
			}
			else text += "0";
		}
	text += "]];";
	document.getElementById('worldfile').value = text;
}