var worldTileset, worldAutoTiles, worldAnim, worldTiles, blockedTiles, mapEvents, mapExists = false, viewBlocking = false;

var scriptLoading = false;
var gameWindow;

var bottomPos, leftPos;

function loadWindow(){
	document.write("<div style='position:absolute; top:0px; left:0px;'><div id='gameWindow' class='gameWindow' style='overflow:hidden;'></div>");
	gameWindow = document.getElementById('gameWindow');
}

function loadMap(map_src){
	map_src = map_src.toLowerCase();
	map_src = "maps/"+map_src+".js";
	scriptLoading = true;
	mapExists = false;
	while(gameWindow.hasChildNodes()) gameWindow.removeChild(gameWindow.firstChild);
	var script = document.createElement('script');
	script.type = 'text/javascript';
	script.onreadystatechange = function(){if(this.readyState == 'complete' || this.readyState == 'loaded') finishLoadMap();}
	script.onload = finishLoadMap;
	script.src = map_src;
	gameWindow.appendChild(script);
}

function finishLoadMap(){
	if(!scriptLoading) return;
	scriptLoading = false;
	if(!mapExists) return;
	var tilemapClass = getStyleClass('tilemap');
	tilemapClass.style.backgroundImage = "url('images/Tilesets/"+worldTileset+"')";
	tilemapClass.style.backgroundRepeat = 'no-repeat';
	for(var n=0; n<8; n++)
		getStyleClass('n'+n).style.backgroundImage = "url('images/Autotiles/"+worldAutoTiles[n]+"')";
	loadTileLayer(0);
	loadTileLayer(1);
	if(viewBlocking){
		var d = document.createElement("div"); d.className = 'borderBlackout'; d.style.width = gameWindow.style.width;
		d.style.height = gameWindow.style.height; d.style.backgroundImage = "url('images/blackout2.png')"; gameWindow.appendChild(d);
	}
	loadTileLayer(2);
	if(viewBlocking){
		for(var y=0; y<worldY; y++)
			for(var x=0; x<worldX; x++)
				if(blockedTiles[y*worldX+x] == 1){
					var d = document.createElement("div"); d.className = 'tile'; d.style.left = (x*32)+'px'; d.style.bottom = (y*32)+'px';
					d.style.backgroundImage = "url('images/blanktile.gif')"; gameWindow.appendChild(d);
				}
	}
	updateAnimElemList();
}

function getClassName(idx){
	if(idx == -1) return 'tile tilemap';
	if(idx < 8) return 'auto tile n'+idx;
	return 'autoInner n'+(idx-8);
}

function loadTileLayer(l){
	for(var i=0; i<worldTiles.length; i++){
		var t = worldTiles[i];
		if(t[5] != l && (t[5] < 2 || l != 2)) continue;
		if(bottomPos != -1) if(Math.floor(t[3]/32)*32 == bottomPos) t[3] -= bottomPos; else continue;
		if(leftPos != -1) if(Math.floor(t[4]/32)*32 == leftPos) t[4] -= leftPos; else continue;
		var anim = -1;
		if(t[2] != -1) anim = t[2]%8;
		var tile = document.createElement("div");
		tile.className = getClassName(t[2]); if(anim!=-1 && worldAnim[anim]) tile.setAttribute('tileanim',1);
		tile.style.backgroundPosition = t[0]+'px '+t[1]+'px'; tile.style.bottom = t[3]; tile.style.left = t[4];
		gameWindow.appendChild(tile);
	}
}