var monster_db = new Array();
function registerMonster(monster){
	var id = monster_db.length;
	monster_db[id] = monster;
	monster.getReference = function(){return "monster_db["+id+"]";};
	monster.m_id = id;
	return monster;
}

function getMonsterReward(monster, exp, stat_ct, chest){
	if(typeof(chest) == 'undefined') chest = (stat_ct > 40)?1:0;
	var goldgain = Math.floor(2*Math.pow(exp, 0.8));
	var items = new Array();
	var ct = 0;
	for(var i=0; i<4; i++){
		var item = item_db[Math.floor(Math.random()*item_db.length)];
		if(item.cost < Math.floor(goldgain*(1+Math.random()))){
			goldgain = Math.max(0, goldgain-Math.floor(item.cost*(1+Math.random())));
			items[ct++] = item;
		}
	}
	if(goldgain > 0) items[ct++] = createPurse(goldgain);
	monsterReward(monster, chest, function(){
		var text = "";
		for(var i=0; i<items.length; i++){
			if(i != 0) if(i == items.length-1) text += " and "; else text += ", ";
			text += "a "+items[i].name;
			addItem(items[i]);
		}
		if(items.length == 0) text = "nothing..";
		showDialog("Found "+text+".", 'middle');
	});
}

function createMonster(name, img, stats, def_attr, atk_attr, weapon, skills, aggro_range, chest_type, layer, anim){
	var monster = new Object();
	if(weapon.length > 6) weapon[7] = weapon[6];
	weapon[6] = atk_attr;
	monster.name = name; monster.img = img; monster.stats = stats; monster.weapon = weapon; monster.skills = skills; monster.layer = layer;
	monster.aggro_range = aggro_range; monster.chest_type = chest_type; monster.def_attr = def_attr; monster.anim = anim;
	monster.stat_ct = 0; for(var i=0; i<stats.length; i++) monster.stat_ct += stats[i];
	monster.spawn = function(lvl, x, y){
		if(typeof(x) == 'undefined'){var pos = getFreePos(); x = pos[0]; y = pos[1];}
		var m_stats = levelUp(this.stats, lvl);
		var monster = spawnUnit(AI, this.name, this.img, x, y, m_stats);
		monster.setMovement(MOVE_RANDOM);
		monster.weapon = createSummonWeapon(monster, this.weapon, lvl);
		monster.skills = this.skills; monster.level = lvl; monster.attribute = this.def_attr;
		if(typeof(this.layer) != 'undefined') monster.setLayer(this.layer);
		if(typeof(this.anim) != 'undefined') monster.setAnim(this.anim);
		//exp = Math.max(20, Math.floor(Math.pow(this.stat_ct*0.2, 2.5)-40));
		var exp = Math.floor(Math.pow(nextLevelEXP(Math.ceil(lvl*(this.stat_ct/50)))*(this.stat_ct/50), 0.9));
		makeMonster(monster, this.aggro_range, exp);
		getMonsterReward(monster, exp, this.stat_ct, this.chest_type);
		return monster;
	}
	monster.blocking = function(){if(this.layer) return (this.layer>=3)?1:0; else return 1;}
	return monster;
}

function monsterSummon(monster, minlvl, maxlvl, apcost, complexity){
	return registerSkill(createSummonSkill(monster.name, "Summons "+monster.name+".", monster.img, copyAr(monster.stats), monster.def_attr, monster.weapon, monster.skills, minlvl, maxlvl, apcost, complexity, monster.layer, monster.anim));
}

function getPartyLevel(){var l =0; for(var c=0; c<party.length; c++) l += party[c].level*(isGuide(party[c])?0.2:1); return Math.floor(l);}

function spawnMonsterParty(t_lvl, monsters){
	if(Math.random() > Math.sqrt(t_lvl)) return;
	t_lvl *= getPartyLevel();
	var unit = getPlayerUnit();
	var minlvl = 0.5*t_lvl, maxlvl = t_lvl;
	var i=100;
	while((t_lvl >= 0) & (i > 0)){
		i--;
		var m_id;
		if(monsters){m_id = monsters[Math.floor(Math.random()*monsters.length)];}
		else {m_id = Math.floor(Math.random()*monster_db.length);}
		var m = monster_db[m_id];
		var pos = getFreePos();
		if(!pos) break;
		if(PathfindLen(pos[0], pos[1], Math.floor(unit.x), Math.floor(unit.y), m.blocking()) == worldX+worldY) continue;
		var lvl = (minlvl+Math.random()*(maxlvl-minlvl));
		lvl = Math.min(lvl, t_lvl);
		t_lvl -= lvl;
		var l = Math.floor(lvl*(50/m.stat_ct)+0.5);
		if(l <= 0) continue;
		m.spawn(l, pos[0], pos[1]);
	}
}

function spawnRandomMonster(minlvl, maxlvl, monsters){
	var m_id;
	if(monsters){m_id = monsters[Math.floor(Math.random()*monsters.length)];}
	else {m_id = Math.floor(Math.random()*monster_db.length);}
	var lvl = minlvl+Math.floor(Math.random()*(maxlvl-minlvl)+0.5);
	var pos = getFreePos();
	if(pos) return monster_db[m_id].spawn(lvl, pos[0]. pos[1]); else return false;
}

