var CHEAP_WEAPON_MARKET = 0, CHEAP_ARMOR_MARKET = 1, CHEAP_OTHER_MARKET = 2, CHEAP_ITEM_MARKET = 3, CHEAP_MAGIC_MARKET = 4, FINE_WEAPON_MARKET = 5, FINE_ARMOR_MARKET = 6, FINE_OTHER_MARKET = 7, FINE_ITEM_MARKET = 8, FINE_MAGIC_MARKET = 9, NUM_MARKETS = 10;
var PI = 3.1415926535897932384626433832795;
var marketItems = new Array(NUM_MARKETS);
for(var i=0; i<NUM_MARKETS; i++) marketItems[i] = new Array();

var markets = [1,1,1,1,1,1,1,1,1,1], marketPeriod = [2, 1.8, 1.2, 3, 1.2, 4, 3.6, 2.4, 6, 8, 6], marketVariance = [0.2, 0.15, 0.25, 0.2, 0.25, 0.05, 0.04, 0.06, 0.01, 0.06];
var marketTime = false, marketDelta = PI*0.5*0.125;

function marketTick(){
	if(!marketTime){
		marketTime = new Array(markets.length);
		for(var i=0; i<markets.length; i++)
			marketTime[i] = Math.random()*PI*0.5/marketPeriod[i];
	}
	for(var i=0; i<markets.length; i++){
		marketTime[i] += marketDelta;
		markets[i] = (1-marketVariance[i]*0.5)+marketVariance[i]*Math.cos(marketTime[i]*marketPeriod[i]);
	}
}


var shopName, shopItems;

function computeShopTotal(){
	var o = parseInt(document.getElementById('shopOffer').value); if(!o) o = 0; document.getElementById('shopOffer').value = o;
	var a = parseInt(document.getElementById('shopAmount').value); if(!a) a = 0; document.getElementById('shopAmount').value = a;
	document.getElementById('shopTotal').innerHTML = o*a;
}

var cur_offer, offer_final, last_offer;

function doBuyDeal(i){
	var num = parseInt(document.getElementById('shopAmount').value);
	if(inventory.gold < cur_offer*num){
		document.getElementById('shopResponse').innerHTML = "You don't have "+cur_offer*num+" gold to pay me.";
		if(last_offer) offer_final = true;
		return;
	}
	document.getElementById('shopResponse').innerHTML = "We have a deal.";
	inventory.gold -= cur_offer*num;
	addItems(shopItems[i], num);
	document.getElementById('goldAmount').innerHTML = inventory.gold+" Gold";
	offer_final = true;
	setTimeout("showShopItems()", 1000);
}

function makeBuyOffer(i){
	var offer = parseInt(document.getElementById('shopOffer').value);
	if(offer >= cur_offer){doBuyDeal(i); return;}
	if(offer_final){
		document.getElementById('shopResponse').innerHTML = cur_offer+" is my final offer. Take it or leave it.";
		return;
	}
	if(offer < getMarketValue(shopItems[i].cost, shopItems[i].market)){
		offer_final = true;
		document.getElementById('shopResponse').innerHTML = "I'd be crazy to sell it for that cheap! I'll sell it for no less than "+cur_offer+" gold.";
		return;
	}
	var mincost = getProfit(shopItems[i].cost, shopItems[i].market, parseInt(document.getElementById('shopAmount').value), 0.5, 0.1, 0.3);
	if(!last_offer){
		cur_offer = Math.max(mincost, cur_offer-Math.ceil((cur_offer-mincost)*0.05));
		if(cur_offer == offer){doBuyDeal(i); return;}
		if(cur_offer == mincost){
			document.getElementById('shopResponse').innerHTML = "I'll sell it for no less than "+cur_offer+" gold.";
			offer_final = true;
		}
		else document.getElementById('shopResponse').innerHTML = offer+" is too little. How about "+cur_offer+"?";
		last_offer = offer;
		return;
	}
	var d = offer-last_offer;
	if(d < 0){
		offer_final = true;
		document.getElementById('shopResponse').innerHTML = offer+" is even lower! Look, I wont take less than "+cur_offer+" gold.";
	} else if(d == 0){
		if(offer < mincost)
			document.getElementById('shopResponse').innerHTML = "I've told you, "+offer+" is too little. Make it "+cur_offer+" and we'll have a deal.";
		else{
			cur_offer = Math.max(offer, cur_offer-Math.ceil((cur_offer-mincost)*0.15));
			if(cur_offer == offer){doBuyDeal(i); return;}
			document.getElementById('shopResponse').innerHTML = "Alright, I can give it to you for "+cur_offer+", but no less.";
		}
	} else {
		cur_offer = Math.max(Math.max(offer, mincost), cur_offer-d);
		if(cur_offer == offer){doBuyDeal(i); return;}
		if(cur_offer == mincost){
			offer_final = true;
			document.getElementById('shopResponse').innerHTML = cur_offer+" is the best deal I can give you.";
		}
		else
			document.getElementById('shopResponse').innerHTML = offer+" is better, but how about "+cur_offer+"?";
	}
	last_offer = offer;
}

function changeAmount(amt, i){
	var num = Math.max(parseInt(amt.value), 1);
	document.getElementById('shopAmount').value = ""+num;
	cur_offer=getProfit(shopItems[i].cost, shopItems[i].market, num, 0.8, 0.2, 1);
	offer_final=false; last_offer=false;
	document.getElementById('shopResponse').innerHTML = "If you want "+num+" "+shopItems[i].name+((num == 1)?"":"s")+", I can sell "+((num == 1)?"it":"them")+" for "+cur_offer+" gold.";
	document.getElementById('shopOffer').value = ""+cur_offer;
}

function doSellDeal(i){
	document.getElementById('shopResponse').innerHTML = "We have a deal.";
	var num = parseInt(document.getElementById('shopAmount').value);
	inventory.gold += cur_offer*num;
	removeItems(i, num);
	document.getElementById('goldAmount').innerHTML = inventory.gold+" Gold";
	offer_final = true;
	setTimeout("showSellItems()", 1000);
}

function makeSellOffer(i){
	var offer = parseInt(document.getElementById('shopOffer').value);
	if(offer <= cur_offer){doSellDeal(i); return;}
	if(offer_final){
		document.getElementById('shopResponse').innerHTML = cur_offer+" is my final offer. Take it or leave it.";
		return;
	}
	if(offer > getMarketValue(inventory.items[i].item.cost, inventory.items[i].item.market)){
		offer_final = true;
		document.getElementById('shopResponse').innerHTML = "That's way too expensive! It's not worth more than "+cur_offer+" gold.";
		return;
	}
	var maxcost = getProfit(inventory.items[i].item.cost, inventory.items[i].item.market, parseInt(document.getElementById('shopAmount').value), 0.5, -0.1, -0.3);
	if(!last_offer){
		cur_offer = Math.min(maxcost, cur_offer+Math.ceil((maxcost-cur_offer)*0.05));
		if(cur_offer == offer){doSellDeal(i); return;}
		if(cur_offer == maxcost){
			document.getElementById('shopResponse').innerHTML = "I'm not paying more than "+cur_offer+" gold.";
			offer_final = true;
		}
		else document.getElementById('shopResponse').innerHTML = offer+" is too much. How about "+cur_offer+"?";
		last_offer = offer;
		return;
	}
	var d = last_offer-offer;
	if(d < 0){
		offer_final = true;
		document.getElementById('shopResponse').innerHTML = offer+" is even more expensive! Look, I wont pay more than "+cur_offer+" gold.";
	} else if(d == 0){
		if(offer > maxcost)
			document.getElementById('shopResponse').innerHTML = "I've told you, "+offer+" is too much. Make it "+cur_offer+" and we'll have a deal.";
		else{
			cur_offer = Math.min(offer, cur_offer+Math.ceil((maxcost-cur_offer)*0.15));
			if(cur_offer == offer){doSellDeal(i); return;}
			document.getElementById('shopResponse').innerHTML = "I guess I can pay "+cur_offer+" gold for it, but no more.";
		}
	} else {
		cur_offer = Math.min(Math.min(offer, maxcost), cur_offer+d);
		if(cur_offer == offer){doSellDeal(i); return;}
		if(cur_offer == maxcost){
			offer_final = true;
			document.getElementById('shopResponse').innerHTML = cur_offer+" is the most I can give you.";
		}
		else
			document.getElementById('shopResponse').innerHTML = offer+" is better, but how about "+cur_offer+"?";
	}
	last_offer = offer;
}

function changeSellAmount(amt, i){
	var num = Math.max(Math.min(inventory.items[i].count, parseInt(amt.value)), 1);
	document.getElementById('shopAmount').value = ""+num;
	cur_offer=getProfit(inventory.items[i].item.cost, inventory.items[i].item.market, num, 0.8, -0.2, -1);
	offer_final=false; last_offer=false;
	document.getElementById('shopResponse').innerHTML = "If you're selling "+num+" "+inventory.items[i].item.name+((num == 1)?"":"s")+", I can buy "+((num == 1)?"it":"them")+" for "+cur_offer+" gold.";
	document.getElementById('shopOffer').value = ""+cur_offer;
}

function lerp(a, b, t){return a*(1-t)+b*t;}

function getProfit(val, market, amount, curve, profit, variance){
	var isqa = 1/Math.pow(amount, curve);
	return Math.ceil(val*markets[market]*(1+profit*isqa+lerp(0, variance*isqa, marketVariance[market]/marketPeriod[market])));
}

function getMarketValue(val, market){return Math.ceil(val*markets[market]);}

function buyItem(i){
	var text = "<b>Purchase:</b><br>"+showItem(shopItems[i])+"<br><br>";
	text += "<b>"+shopName+"</b>: <div style='display:inline;' id='shopResponse'></div><br>";
	cur_offer = getProfit(shopItems[i].cost, shopItems[i].market, 1, 0.8, 0.2, 1); offer_final = false; last_offer = false;
	text += "<b>Counter Offer:</b> <input id='shopOffer' onfocus='textareafocused=true;' onblur='textareafocused=false;' onchange='computeShopTotal();' value='"+cur_offer+"' type=text size=4> x ";
	text += "<input id='shopAmount' onfocus='textareafocused=true;' onblur='textareafocused=false;' onchange='changeAmount(this, "+i+"); computeShopTotal();' value='1' type=text size=4> = <div style='display:inline;' id='shopTotal'></div> Gold<br><br>";
	text += "<a href='javascript:makeBuyOffer("+i+");'>Make Offer</a>&nbsp;&nbsp;&nbsp;&nbsp;<a href='javascript:showShopItems();'>Decline Offer</a>";
	document.getElementById('shopPanel').innerHTML = "<center>"+text+"</center>";
	document.getElementById('shopResponse').innerHTML = "The "+shopItems[i].name+" costs "+cur_offer+" gold.";
	document.getElementById('shopOffer').value = ""+cur_offer;
	document.getElementById('shopAmount').value = "1";
	computeShopTotal();
}

function sellItem(i){
	var text = "<b>Sell:</b><br>"+showItem(inventory.items[i].item)+"<br><br>";
	text += "<b>"+shopName+"</b>: <div style='display:inline;' id='shopResponse'></div><br>";
	cur_offer = getProfit(inventory.items[i].item.cost, inventory.items[i].item.market, 1, 0.8, -0.2, -1); offer_final = false; last_offer = false;
	text += "<b>Counter Offer:</b> <input id='shopOffer' onfocus='textareafocused=true;' onblur='textareafocused=false;' onchange='computeShopTotal();' value='"+cur_offer+"' type=text size=4> x ";
	text += "<input id='shopAmount' onfocus='textareafocused=true;' onblur='textareafocused=false;' onchange='changeSellAmount(this, "+i+"); computeShopTotal();' value='1' type=text size=4> = <div style='display:inline;' id='shopTotal'></div> Gold<br><br>";
	text += "<a href='javascript:makeSellOffer("+i+");'>Make Offer</a>&nbsp;&nbsp;&nbsp;&nbsp;<a href='javascript:showSellItems();'>Decline Offer</a>";
	document.getElementById('shopPanel').innerHTML = "<center>"+text+"</center>";
	document.getElementById('shopResponse').innerHTML = "I can offer you "+cur_offer+" gold for the "+inventory.items[i].item.name+".";
	document.getElementById('shopOffer').value = ""+cur_offer;
	document.getElementById('shopAmount').value = "1";
	computeShopTotal();
}

function showShopItems(){
	var text = "<table width=95% border=1>";
	for(var i=0; i<shopItems.length; i++)
		text += "<tr><td height=33 style='cursor:pointer;' onclick='buyItem("+i+");'>"+showItem(shopItems[i], "buyItem("+i+")")+"</td><td>"+(getProfit(shopItems[i].cost, shopItems[i].market, 1, 0.8, 0.2, 1))+" Gold</td></tr>";
	if(shopItems.length == 0) text += "<tr><td height=33><i>The shop has no items in stock.</i></td></tr>";
	text += "</table>";
	document.getElementById('shopPanel').innerHTML = "<center>"+text+"</center>";
}

function showSellItems(){
	var text = "<table width=95% border=1>";
	for(var i=0; i<inventory.items.length; i++)
		text += "<tr><td height=33 style='cursor:pointer;' onclick='sellItem("+i+");'>"+showItem(inventory.items[i].item, "sellItem("+i+")")+"</td><td>"+(getProfit(inventory.items[i].item.cost, inventory.items[i].item.market, 1, 0.8, -0.2, -1))+" Gold</td></tr>";
	if(inventory.items.length == 0) text += "<tr><td height=33><i>You have no items to sell.</i></td></tr>";
	text += "</table>";
	document.getElementById('shopPanel').innerHTML = "<center>"+text+"</center>";
}

function generalShop(name){
	marketShop(name, [0,5,1,6,2,7,3,8,4,9]);
}

function marketShop(name, markets){
	var ar = new Array();
	for(var i=0; i<markets.length; i++){
		var items = marketItems[markets[i]];
		for(var c=0; c<items.length; c++) ar[ar.length] = items[c];
	}
	showShop(name, ar);
}

function showShop(name, items){
	if(msg_show || end_game || inBattle) return;
	shopName = name;
	shopItems = items;
	sponsor_sprite.style.width = '0px';
	msg_div.style.visibility = 'visible';
	msg_div.className = 'blankout';
	msg_div.onclick = function(){if(!inDialog) closeMsg();};
	msg_align.style.verticalAlign = 'middle';
	msg_div.callback = false;
	var text = "<table border=1 width=95% height=90% onmouseover='inDialog = true;' onmouseout='inDialog = false;'><tr><td align=center><b>"+name+"'s Shop</b></td></tr><tr><td><div id='shopPanel' style='width:100%; height:300px; overflow:auto;'></div></td></tr>";
	text += "<tr><td align=center><a href='javascript:showShopItems()'>Buy Items</a>&nbsp;&nbsp;&nbsp;&nbsp;<div style='display:inline; font-weight:bold;' id='goldAmount'></div>&nbsp;&nbsp;&nbsp;&nbsp;<a href='javascript:showSellItems()'>Sell Items</a></td></tr></table>";
	msg_text.innerHTML = text;
	document.getElementById('goldAmount').innerHTML = getIcon(GOLD_ICON)+" "+inventory.gold;
	showShopItems();
	menuOpen = false;
	msg_show = true;
}