//NOTE: cure and revive skills only work on party members.
//NOTE: monsters can only use attack skills (with no AoE), heal skills, mod up skills, mod down skills, summon skills, ap damage skills (all but cure, revive and tame)

var ATK_SKILL = 1, HEAL_SKILL = 2, REVIVE_SKILL = 3, OTHER_SKILL = 4;

var skill_db = new Array();

function registerSkill(skill){
	var id = skill_db.length;
	skill_db[id] = skill;
	skill.getReference = function(){return "skill_db["+id+"]";};
	return skill;
}

function createAtkSkill(name, icon, descr, anim, attrib, mindmg, maxdmg, crit, apcost, complexity, range, aoe){
	var skill = createWeapon(name, icon, descr, WISDOM, complexity);
	skill.use = false; skill.skilltype = ATK_SKILL;
	setDiamondRange(skill, 1, range);
	setDiamondAoE(skill, 0, aoe);
	skill.getReference = function(){return "createAtkSkill(\""+name+"\","+icon+",\""+descr+"\",\""+anim+"\","+attrib+","+mindmg+","+maxdmg+","+crit+","+apcost+","+complexity+","+range+","+aoe+")";};
	skill.mindamage = mindmg;
	skill.maxdamage = maxdmg;
	skill.critical = crit;
	skill.apcost = apcost;
	skill.attribute = attrib;
	skill.animation = eval(anim);
	skill.skillStr = function(stats){return "<span style='white-space: nowrap; text-decoration:underline;'>Dmg: "+damageStr(this, stats)+"; AP: "+this.apcost+"</span>";}
	return skill;
}

function createHealSkill(name, descr, minheal, maxheal, apcost, complexity){
	var skill = createWeapon(name, 128, descr, WISDOM, complexity);
	skill.getReference = function(){return "createHealSkill(\""+name+"\",\""+descr+"\","+minheal+","+maxheal+","+apcost+","+complexity+")";};
	setDiamondRange(skill, 0, 1);
	setDiamondAoE(skill, 0, 0);
	skill.mindamage = minheal; skill.maxdamage = maxheal;
	skill.use = false; skill.skilltype = HEAL_SKILL;
	skill.baseHeal = function(stats, attribute, x, y, color){return this.baseDamage(stats, attribute, x, y, color);};
	skill.apcost = apcost;
	skill.animation = healAnim;
	skill.handleevent = function(event){
		if(event.health == 0) return;
		event.health += attack_weapon.baseHeal(attacker_stats, false, getX(event), getY(event), "#1f63eb");
		event.health = Math.min(event.health, event.maxhealth);
	}
	skill.skillStr = function(stats){return "<span style='white-space: nowrap; text-decoration:underline;'>Heal: "+damageStr(this, stats)+"; AP: "+this.apcost+"</span>";}
	return skill;
}

function updateStats(event){
	event.maxhealth = getCharacterHP(event.stats[0]); event.maxap = getCharacterAP(event.stats[1]);
	event.range = getCharacterRange(event.stats[2]);
}

function createModUpSkill(name, descr, modstat, minup, maxup, apcost, complexity){
	var skill = createWeapon(name, 142, descr, WISDOM, complexity);
	skill.getReference = function(){return "createModUpSkill(\""+name+"\",\""+descr+"\","+modstat+","+minup+","+maxup+","+apcost+","+complexity+")";};
	setDiamondRange(skill, 0, 1);
	setDiamondAoE(skill, 0, 0);
	skill.mindamage = minup; skill.maxdamage = maxup;
	skill.use = false; skill.skilltype = OTHER_SKILL;
	skill.baseUp = function(stats, attribute, x, y, color){return this.baseDamage(stats, attribute, x, y, color);};
	skill.apcost = apcost; skill.modstat = modstat;
	skill.animation = upAnim;
	skill.handleevent = function(event){
		if(event.health == 0) return;
		var s = attack_weapon.baseUp(attacker_stats, false, getX(event), getY(event), "#1f63eb");
		if(event.member){event.member.stats[attack_weapon.modstat] += s; event.member.modifiers[attack_weapon.modstat] += s; event.member.updateStats();}
		else if(event.stats){event.stats[attack_weapon.modstat] += s; updateStats(event);}
	}
	skill.skillStr = function(stats){return "<span style='white-space: nowrap; text-decoration:underline;'>"+statNames[this.modstat]+" Up: "+damageStr(this, stats)+"; AP: "+this.apcost+"</span>";}
	return skill;
}

function createModDownSkill(name, descr, modstat, mindown, maxdown, apcost, complexity){
	var skill = createWeapon(name, 143, descr, WISDOM, complexity);
	skill.getReference = function(){return "createModDownSkill(\""+name+"\",\""+descr+"\","+modstat+","+mindown+","+maxdown+","+apcost+","+complexity+")";};
	setDiamondRange(skill, 0, 3);
	setDiamondAoE(skill, 0, 0);
	skill.mindamage = mindown; skill.maxdamage = maxdown;
	skill.use = false; skill.skilltype = OTHER_SKILL;
	skill.baseDown = function(stats, attribute, x, y, color){return this.baseDamage(stats, attribute, x, y, color);};
	skill.apcost = apcost; skill.modstat = modstat;
	skill.animation = downAnim;
	skill.handleevent = function(event){
		if(event.health == 0) return;
		var s = attack_weapon.baseDown(attacker_stats, false, getX(event), getY(event), "#ff4036");
		if(event.member){
			s = Math.min(event.member.stats[attack_weapon.modstat], s);
			event.member.stats[attack_weapon.modstat] -= s;
			event.member.modifiers[attack_weapon.modstat] -= s;
			event.member.updateStats();
		}
		else if(event.stats){event.stats[attack_weapon.modstat] = Math.max(0, event.stats[attack_weapon.modstat]-s); updateStats(event);}
	}
	skill.skillStr = function(stats){return "<span style='white-space: nowrap; text-decoration:underline;'>"+statNames[this.modstat]+" Down: "+damageStr(this, stats)+"; AP: "+this.apcost+"</span>";}
	return skill;
}

function createCureSkill(name, descr, apcost){
	var skill = createWeapon(name, 137, descr, WISDOM, 0);
	skill.getReference = function(){return "createCureSkill(\""+name+"\",\""+descr+"\","+apcost+")";};
	setDiamondRange(skill, 0, 1);
	setDiamondAoE(skill, 0, 0);
	skill.use = false; skill.skilltype = OTHER_SKILL;
	skill.apcost = apcost;
	skill.animation = cureAnim;
	skill.handleevent = function(event){
		if(event.health == 0) return;
		if(event.member){
			for(var i=0; i<event.member.stats.length; i++)
				event.member.stats[i] -= event.member.modifiers[i];
			event.member.updateStats();
		}
	}
	skill.skillStr = function(stats){return "<span style='white-space: nowrap; text-decoration:underline;'>Removes all modifiers; AP: "+this.apcost+"</span>";}
	return skill;
}

function createReviveSkill(name, descr, apcost){
	var skill = createWeapon(name, 159, descr, WISDOM, 0);
	skill.getReference = function(){return "createReviveSkill(\""+name+"\",\""+descr+"\","+apcost+")";};
	setEmptyRange(skill, 1, 1);
	setDiamondAoE(skill, 0, 0);
	skill.use = false; skill.skilltype = REVIVE_SKILL;
	skill.apcost = apcost;
	skill.animation = reviveAnim;
	skill.handleevent = function(event){}
	skill.cast = function(x,y){
		if(worldGrid[y*worldX+x] != null){showUIStatus("Can only revive on an empty square."); return false;}
		showMenu();
		showPartySelector(function(i){
			if(party[i].health != 0){showUIStatus("Cannot revive conscious party members."); return;}
			if(attack_item) removeItem(attack_item);
			selected.ap -= attack_apcost;
			party[i].health = Math.max(1, Math.floor(party[i].maxhealth*0.1));
			closeMsg();
			refreshUI();
			party[i].x = x; party[i].y = y;
			fadeIn(party[i].loadUnit());
			if(attack_weapon.animation) attack_weapon.animation(x, y);
		});
		return false;
	}
	skill.skillStr = function(stats){return "<span style='white-space: nowrap; text-decoration:underline;'>Revives unconscious party members; AP: "+this.apcost+"</span>";}
	return skill;
}

function createApDmgSkill(name, descr, mindamage, maxdamage, apcost, complexity){
	var skill = createWeapon(name, 118, descr, WISDOM, complexity);
	skill.getReference = function(){return "createApDmgSkill(\""+name+"\",\""+descr+"\","+mindamage+","+maxdamage+","+apcost+","+complexity+")";};
	setDiamondRange(skill, 0, 1);
	setDiamondAoE(skill, 0, 0);
	skill.apdamage = true;
	skill.mindamage = mindamage; skill.maxdamage = maxdamage;
	skill.use = false; skill.skilltype = OTHER_SKILL;
	skill.apcost = apcost;
	skill.animation = bindAnim;
	skill.handleevent = function(event){
		if(event.health == 0) return;
		event.ap -= attack_weapon.baseDamage(attacker_stats, false, getX(event), getY(event), "#ff4036");
		if(event.ap < 0) event.ap = 0;
	}
	skill.skillStr = function(stats){return "<span style='white-space: nowrap; text-decoration:underline;'>AP Down: "+damageStr(this, stats)+"; AP: "+this.apcost+"</span>";}
	return skill;
}

function createTameSkill(name, descr, minper, maxper, apcost, complexity){
	var skill = createWeapon(name, 134, descr, WISDOM, complexity);
	skill.getReference = function(){return "createTameSkill(\""+name+"\",\""+descr+"\","+minper+","+maxper+","+apcost+","+complexity+")";};
	setDiamondRange(skill, 0, 1);
	setDiamondAoE(skill, 0, 0);
	skill.mindamage = minper*100000; skill.maxdamage = maxper*100000;
	skill.use = false; skill.skilltype = OTHER_SKILL;
	skill.apcost = apcost;
	skill.animation = tameAnim;
	skill.handleevent = function(event){
		if(event.health == 0 || event.player != AI) return;
		var wisdom = attacker_stats[WISDOM];
		attacker_stats[WISDOM] -= (event.member)?event.member.stats[WISDOM]:((event.stats)?event.stats[WISDOM]:5);
		var per = attack_weapon.baseDamage(attacker_stats);
		attacker_stats[WISDOM] = wisdom;
		if(Math.random() < per*0.00001){
			showFloatText("<font style='color:#1f63eb;'>Tamed!</font>", getX(event), getY(event));
			event.setPlayer(player);
		} else showFloatText("<font style='color:#ff4036;'>Fail</font>", getX(event), getY(event));
	}
	skill.skillStr = function(stats){return "<span style='white-space: nowrap; text-decoration:underline;'>Tames enemy; AP: "+this.apcost+"</span>";}
	return skill;
}

function levelUp(stats, lvl){
	var ret = copyAr(stats);
	for(var l=1; l<lvl; l++){
		var v = Math.pow(0.9, l);
		for(var i=0; i<ret.length; i++)
			ret[i] += ret[i]*0.3*v;
	}
	return ret;
}

function createSummonWeapon(unit, weap, lvl){
	var mindmg = Math.floor(weap[0]*(1+lvl*0.25)), maxdmg = Math.floor(weap[1]*(1+lvl*0.25));
	if(weap.length > 7){
		if(weap[7] > 3)
			return createRangedWeapon("", 0, "", weap[5], mindmg, maxdmg, weap[2], Math.floor(weap[3]*Math.pow(lvl,0.15)), Math.floor(weap[4]*Math.sqrt(lvl)), 0, weap[7]);
		else
			return createSpearWeapon("", 0, "", weap[5], mindmg, maxdmg, weap[2], Math.floor(weap[3]*Math.pow(lvl,0.15)), Math.floor(weap[4]*Math.sqrt(lvl)), 0, weap[7]);
	}
	if(weap.length < 7) return barehanded;
	var weapon = createMeleeWeapon("", 0, "", weap[5], mindmg, maxdmg, weap[2], Math.floor(weap[3]*Math.pow(lvl,0.2)), Math.floor(weap[4]*Math.sqrt(lvl)), 0);
	weapon.attribute = weap[6];
	weapon.apcost = Math.min(weapon.apcost, unit.maxap);
	return weapon;
}

function createSummonSkill(name, descr, img, stats, attr, weapon, skills, minlvl, maxlvl, apcost, complexity, layer, anim){
	var skill = createWeapon("Summon "+name, 129, descr, WISDOM, complexity);
	skill.getReference = function(){return "createSummonSkill(\""+name+"\",\""+descr+"\",\""+img+"\","+getArStr(stats)+","+attr+","+getArStr(weapon)+","+getArStr(skills)+","+minlvl+","+maxlvl+","+apcost+","+complexity+")";};
	for(var i=0; i<skill_db.length; i++)
		if(skill.name == skill_db[i].name) skill.getReference = skill_db[i].getReference;
	setEmptyRange(skill, 1, 1);
	setDiamondAoE(skill, 0, 0);
	skill.summonval = 0;
	for(var i=0; i<stats.length; i++)
		skill.summonval += stats[i];
	skill.summonval *= Math.pow(1.3, (minlvl+maxlvl)*0.5);
	skill.mindamage = minlvl; skill.maxdamage = maxlvl;
	skill.use = false; skill.skilltype = OTHER_SKILL;
	skill.apcost = apcost;
	skill.animation = reviveAnim; skill.layer = layer; skill.anim = anim;
	skill.stats = stats; skill.weapon = weapon; skill.skills = skills; skill.attr = attr;
	skill.handleevent = function(event){}
	skill.cast = function(x,y){
		if(worldGrid[y*worldX+x] != null){showUIStatus("Can only summon on an empty square."); return false;}
		if(attack_item) removeItem(attack_item);
		selected.ap -= attack_apcost;
		var lvl = attack_weapon.baseDamage(attacker_stats);
		if(lvl == 0){showFloatText("<font style='color:#ff4036;'>Fail!</font>", x, y); return;}
		var m_stats = levelUp(this.stats, lvl);
		var unit = spawnUnit(cur_player, name, img, x, y, m_stats);
		unit.skills = this.skills; unit.weapon = createSummonWeapon(unit, this.weapon, lvl); unit.attribute = this.attr;
		if(typeof(this.anim) != 'undefined'){var anim_id = this.anim; unit.callback = function(){this.setAnim(anim_id);}}
		fadeIn(unit);
		unit.level = lvl;
		if(typeof(this.layer) != 'undefined') unit.setLayer(this.layer);
		if(cur_player == AI){
			var stat_ct = 0; for(var i=0; i<this.stats.length; i++) stat_ct += this.stats[i];
			var exp = Math.floor(nextLevelEXP(lvl-1)*(stat_ct/50));
			makeMonster(unit, 0, exp);
			getMonsterReward(unit, exp, stat_ct);
		}
		if(attack_weapon.animation) attack_weapon.animation(x, y);
		return false;
	}
	skill.skillStr = function(stats){return "<span style='white-space: nowrap; text-decoration:underline;'>Lvl: "+damageStr(this, stats)+"; AP: "+this.apcost+"</span>";}
	return skill;
}