//world handling

var worldGrid = new Array(worldX*worldY);

function cellEmpty(x, y){return (x < 0) | (y < 0) | (x >= worldX) | (y >= worldY) | (worldGrid[y*worldX+x] == null);}

var worldTileset, worldAutoTiles, worldAnim, worldTiles, blockedTiles, mapEvents, mapExists = false;
var gameWindow, cursor, selarea, aoearea, uibar, msg_div, msg_align, msg_text, creditsPane, gameMenu, menuBox;
var nlayers = 3, layers;

function setSprite(event, img_url){
	if(img_url == 'none'){
		event.style.backgroundImage = '';
		return;
	}
	event.sprite = img_url;
	var img = new Image();
	img.onload = function(){
		event.width = img.width*0.25; event.height = img.height*0.25;
		setX(event, event.x); setY(event, event.y);
		event.style.width = event.width+'px';
		event.style.height = event.height+'px';
		event.style.backgroundImage = "url('images/Characters/"+event.sprite+"')";
		event.style.backgroundPosition = (-event.frame*event.width)+'px '+(-event.facing*event.height)+'px';
	}
	img.src = "images/Characters/"+event.sprite;
}

function setPlayer(event, p){
	if(event.player == p) return;
	arRemove(playerUnits[event.player], event);
	if(p != 0) add(playerUnits[p], event);
	event.player = p;
	if(inBattle && playerUnits[AI].length == 0) winBattle();
}

function setEventX(event, x){
	if((x < 0) | (x >= worldX)) return false;
	var idx = event.y*worldX+x;
	if(event.blocker == 1){if(worldGrid[idx] != null) return false; worldGrid[event.y*worldX+event.x] = null;}
	setX(event, x);
	if(event.blocker == 1) worldGrid[idx] = event;
	return true;
}

function setEventY(event, y){
	if((y < 0) | (y >= worldY)) return false;
	var idx = y*worldX+event.x;
	if(event.blocker == 1){if(worldGrid[idx] != null) return false; worldGrid[event.y*worldX+event.x] = null;}
	setY(event, y);
	if(event.blocker == 1) worldGrid[idx] = event;
	return true;
}

function setEventPos(event, x, y){
	if((x < 0) | (x >= worldX) | (y < 0) | (y >= worldY)) return false;
	var idx = y*worldX+x;
	if(event.blocker == 1){if(worldGrid[idx] != null) return false; worldGrid[event.y*worldX+event.x] = null;}
	setX(event, x); setY(event, y);
	if(event.blocker == 1) worldGrid[idx] = event;
	return true;
}

function setEventDir(event, d){
	event.facing = d;
	event.style.backgroundPosition = (-event.frame*event.width)+'px '+(-event.facing*event.height)+'px';
}

function setEventFrame(event, f){
	event.frame = f;
	event.style.backgroundPosition = (-event.frame*event.width)+'px '+(-event.facing*event.height)+'px';
}

var WALK_LOOP = 1, ROTATE_LOOP = 2, REVERSE = true;
function setEventAnim(event, a, rev){
	event.reverse = rev;
	var olda = event.animfunc;
	event.animfunc = a;
	if((olda == 0) & (a != 0)) addAnimElem(event);
}

var GROUND_P = 0, EVENT_P = 1, ONTOP_P = 2, GROUND_B = 3, EVENT_B = 4, ONTOP_B = 5;
function setEventLayer(event, l){
	if(event.blocker == 1) worldGrid[event.y*worldX+event.x] = null;
	var oldl = event.layer;
	event.layer = l%3;
	event.blocker = (l>=3)?1:0;
	if(event.blocker == 1) worldGrid[event.y*worldX+event.x] = event;
	if(oldl != event.layer){var y = event.y; event.y = -1; setY(event, y);}
	var tmp = selected;
	deselect();
	select(tmp);
}

function spawnBasicEvent(uname, img, x, y){
	return spawnEvent(none, uname, img, x, y, 0, 0, 0, 0, 0, 0.25, 100, 4, 0, 1);
}

function spawnUnit(p, uname, img, x, y, stats){
	var health = getCharacterHP(stats[0]); var ap = getCharacterAP(stats[1]);
	var range = getCharacterRange(stats[2]);
	var unit = spawnEvent(p, uname, img, x, y, 0, 0, health, ap, range, 0.25, 100, 4, 0, 1);
	unit.stats = stats;
	unit.skills = new Array();
	return unit;
}

function add(ar, v){ar[ar.length] = v;}

var MOVE_STILL = 0, MOVE_RANDOM = 1;

function spawnEvent(p, uname, img, x, y, dir, frame, health, ap, range, stepsize, framems, blocker, anim, named){
	x = Math.floor(x); y = Math.floor(y);
	var layer = blocker%3;
	blocker = (blocker>=3)?1:0;
	if(p == player) named = 1;
	var event = document.createElement("div");
	event.className = 'unit'; event.attribute = DEF_LIGHT; event.vars = new Object();
	event.name = uname; event.player = p; event.uname = ((named == 1)?uname:''); event.maxhealth = health; event.health = health; event.maxap = ap; event.ap=ap;
	event.range=range; event.maxrange=range; event.stepsize=stepsize; event.framems=framems; event.frame=frame; event.facing=dir; event.x = -1; event.y = -1;
	event.width = 32; event.height = 32; event.blocker = blocker; event.animfunc = 0; event.layer = layer;
	event.setSprite = function(img_url){setSprite(this, img_url);}; event.setPlayer = function(p){setPlayer(this, p);};
	event.setX = function(x){return setEventX(this, x);}; event.setY = function(y){return setEventY(this, y);}; event.setPos = function(x, y){return setEventPos(this, x, y);};
	event.setDir = function(d){setEventDir(this, d);}; event.setFrame = function(f){setEventFrame(this, f);};
	event.walkOnce = function(rev){this.stframe = this.frame; setEventAnim(this, 3, rev);}; event.rotateOnce = function(rev){this.stdir = this.facing; setEventAnim(this, 4, rev);};
	event.fadeAnim = function(){this.stalpha = 10; setEventAnim(this, 5);}; event.setLayer = function(l){setEventLayer(this, l);}
	event.setSprite(img); setX(event, x); setY(event, y);
	event.faceCell = function(x,y){
		var dx = x-this.x, dy = y-this.y;
		var d = (Math.abs(dx) > Math.abs(dy))?((dx > 0)?2:1):((dy > 0)?3:0);
		setEventDir(this, d);
	};
	event.movement = 0;
	event.setMovement = function(m){if(m == this.movement) return; this.movement = m; if(m != 0) addMovementList(this);}
	event.setAnim = function(a, rev){setEventAnim(this, a, rev);}; event.setAnim(anim);
	event.style.filter="alpha(opacity=100)";
	if(blocker == 1) worldGrid[y*worldX+x] = event;
	if(p != 0) add(playerUnits[p], event);
	add(eventList, event);
	var tmp = selected;
	deselect();
	select(tmp);
	return event;
}

function removeEvent(event){
	if(event.member){
		event.member.update();
		event.member.unit = null;
	}
	if(event.blocker == 1) worldGrid[event.y*worldX+event.x] = null;
	event.parentNode.removeChild(event);
	var p = event.player;
	if(p > 0) arRemove(playerUnits[p], event);
	if(p == player && playerUnits[p].length == 0) gameOverScreen();
	arRemove(eventList, event);
	var tmp = selected;
	deselect();
	select(tmp);
	if(inBattle && playerUnits[AI].length == 0) winBattle();
}

//world building

var blockerObj = true;

function getClassName(idx){
	if(idx == -1) return 'tile tilemap';
	if(idx < 8) return 'auto tile n'+idx;
	return 'autoInner n'+(idx-8);
}

function loadTileLayer(){
	for(var i=0; i<worldTiles.length; i++){
		var t = worldTiles[i];
		var anim = -1;
		if(t[2] != -1) anim = t[2]%8;
		var tile = document.createElement("div");
		tile.className = getClassName(t[2]); if(anim!=-1 && worldAnim[anim]) tile.setAttribute('tileanim',1);
		tile.style.backgroundPosition = t[0]+'px '+t[1]+'px'; tile.style.bottom = t[3]; tile.style.left = t[4];
		layers[Math.min(2,t[5])*worldY+Math.max(0, Math.floor(t[3]*0.03125)-Math.max(0, t[5]-2))].appendChild(tile);
	}
}

function loadEventLayer(){
	for(var i=0; i<mapEvents.length; i++){
		var t = mapEvents[i];
		var ar = t[0];
		mapEvents[i][1] = spawnEvent(getPlayer(ar[14]), ar[1], ar[0], t[2]*INV_TILE_SIZE, t[1]*INV_TILE_SIZE, ar[5], ar[6], ar[7], ar[8], ar[11], ar[9], ar[10], ar[12], ar[13], ar[15]);
		var c = (ar[14]%2); if(c == 1){mapEvents[i][1].setMovement(MOVE_RANDOM);}
		mapEvents[i][1].mapEvent = true;
	}
}

var eventList;

function loadGroundLayers(){
	layers = new Array(nlayers*worldY);
	for(var y=worldY-1; y>=0; y--){
		var layer = document.createElement("div");
		layer.className = 'layer';
		layers[y] = layer;
		gameWindow.appendChild(layer);
	}
	for(var i=0; i<worldX*worldY; i++)
		if(blockedTiles[i] == 1) worldGrid[i] = blockerObj;
	eventList = new Array();
}

function getFreePos(){
	var x, y;
	for(var i=0; i<100; i++){
		x = Math.floor(Math.random()*worldX); y = Math.floor(Math.random()*worldY);
		if(worldGrid[y*worldX+x] == null) return [x,y];
	}
	return false;
}

function loadTopLayers(){
	for(var y=worldY-1; y>=0; y--){
		for(var l = 1; l<=2; l++){
			var layer = document.createElement("div");
			layer.className = 'layer';
			layers[l*worldY+y] = layer;
			gameWindow.appendChild(layer);
		}
	}
	loadTileLayer();
	if(!noMapEvents) loadEventLayer();
	if(party.length == 0){
		var pos = getFreePos();
		if(pos) addPartyMember(createPartyMember("Player", "001-Fighter01.png", pos[0], pos[1], 0, [5,5,5,5,5,5]));
	}
	party[0].loadUnit();
	
}

function getPlayer(c){
	c = Math.floor(c/2);
	var p_ar = [none, AI, player];
	return p_ar[c];
}

function runEventScripts(){
	for(var i=0; i<mapEvents.length; i++){
		var ar = mapEvents[i][0];
		var event = mapEvents[i][1];
		if(ar[2] != '') eval(unescapeStr(ar[2]));
		if(scriptLoading) return;
	}
}

var map_script = null, mapName, scriptLoading = false, mapLoading = false, mapCallback, MAP_DIR = "maps/";

function loadMap(map_src, x, y, callback){
	if(mapLoading | inBattle) return;
	keyMovePath = [];
	movementList = new Array()
	mapLoading = true;
	map_src = map_src.toLowerCase();
	mapName = map_src;
	map_src = MAP_DIR+map_src+".js";
	map_script = map_src;
	mapCallback = callback;
	showMsg("Loading Map...");
	updatePartyMembers();
	nullPartyMembers();
	if(typeof(x) != 'undefined') party[0].x = x; if(typeof(y) != 'undefined') party[0].y = y;
	while(gameWindow.hasChildNodes()) gameWindow.removeChild(gameWindow.firstChild);
	scriptLoading = true;
	mapExists = false;
	var script = document.createElement('script');
	script.type = 'text/javascript';
	script.onreadystatechange = function(){if(this.readyState == 'complete' || this.readyState == 'loaded') preloadMap();}
	script.onload = preloadMap;
	script.onerror = function(){error("Map "+mapName+" does not exist.");}
	script.src = map_src;
	gameWindow.appendChild(script);
}

var preloadImgNum;

function preloadImage(img_src){
	var img = new Image();
	img.onload = function(){preloadImgNum--; if(preloadImgNum <= 0) finishLoadMap();}
	img.src = img_src;
}

function preloadMap(){
	if(!scriptLoading) return;
	scriptLoading = false;
	preloadImgNum = 9+mapEvents.length;
	preloadImage("images/Tilesets/"+worldTileset);
	for(var n=0; n<8; n++) preloadImage("images/Autotiles/"+worldAutoTiles[n]);
	for(var i=0; i<mapEvents.length; i++){
		var sprite = mapEvents[i][0][0];
		if(sprite != 'none') preloadImage("images/Characters/"+sprite);
		else{preloadImgNum--; if(preloadImgNum <= 0) finishLoadMap();}
	}
}

var noMapEvents = false;

function finishLoadMap(){
	if(!mapExists){error("Map "+mapName+" does not exist."); return;}
	mapLoading = false;
	closeMsg();
	selected = null; cur_player = 0;
	for(var i=0; i<worldX*worldY; i++) worldGrid[i] = null;
	for(var i=0; i<players.length; i++) playerUnits[i] = new Array();
	var tilemapClass = getStyleClass('tilemap');
	tilemapClass.style.backgroundImage = "url('images/Tilesets/"+worldTileset+"')";
	tilemapClass.style.backgroundRepeat = 'no-repeat';
	for(var n=0; n<8; n++)
		getStyleClass('n'+n).style.backgroundImage = "url('images/Autotiles/"+worldAutoTiles[n]+"')";
	loadGroundLayers();
	selarea = document.createElement("div");
	selarea.style.visibility = 'hidden';
	gameWindow.appendChild(selarea);
	aoearea = document.createElement("div");
	aoearea.style.visibility = 'hidden'; aoearea.style.position = 'absolute';
	gameWindow.appendChild(aoearea);
	cursor = document.createElement("div");
	cursor.className = 'cursor';
	if(oldX == -1 || oldY == -1) cursor.style.visibility = 'hidden';
	else{cursor.style.bottom = oldY*TILE_SIZE+'px'; cursor.style.left = oldX*TILE_SIZE+'px';}
	gameWindow.appendChild(cursor);
	loadTopLayers();
	updateAnimElemList();
	marketTick();
	clearUIbar();
	startTurn();
	moveUnit = null;sprites = [];resumeGame();
	if(mapCallback){var func = mapCallback; mapCallback = false; func();}
	if(noMapEvents) noMapEvents = false; else{
		runEventScripts();
		saveGame("autosave");
	}
}

var music_player, BGM, BGMct, musicMuted, soundMuted;

var options_text = getCookie("gameOptions");
if(options_text) eval(options_text);

function saveOptions(){setCookie("gameOptions", "musicMuted="+musicMuted+";soundMuted="+soundMuted+";speed_mod="+speed_mod+";doAnimTiles="+doAnimTiles+";");}

function muteMusic(val){
	var oldBGM = BGM;
	BGM = false;
	musicMuted = val;
	if(musicMuted) stopBGM();
	else if(oldBGM && !BGMct) playBGM(oldBGM);
	BGM = oldBGM;
	saveOptions()
}

function muteSound(val){
	soundMuted = val;
	if(soundMuted) stopSE();
	saveOptions();
}

function playBGM(bgm_src, ct){
	if(bgm_src == BGM && !BGMct) return;
	BGM = bgm_src;
	BGMct = ct;
	if(musicMuted) return;
	try{
		if(ct) music_player.PlayBGM(bgm_src, ct-1);
		else music_player.LoopBGM(bgm_src);
	}catch(e){}
}
function stopBGM(){BGM = false; try{music_player.StopBGM();}catch(e){}}
function playSE(se_src){if(soundMuted) return; try{music_player.PlaySE(se_src);}catch(e){}}
function stopSE(){try{music_player.StopSE();}catch(e){}}
function loopSE(se_src){if(soundMuted) return; try{music_player.LoopSE(se_src);}catch(e){}}

function loadGame(){
	document.write("<applet code=MusicPlayer.class width='0' height='0' class='hiddenDiv' id='music_player'></applet>");
	music_player = document.getElementById('music_player');
	document.write("<div style='position:relative; top:0px; left:0px; width:640px; height:540px;'><div id='gameWindow' class='gameWindow'></div>");
	gameWindow = document.getElementById('gameWindow');
	if(document.all) document.write("<div class='mouseMask' onclick='mouseClick();' onmousemove='mouseMove();'></div>");
	else document.write("<div class='mouseMask' onclick='mouseClick(event);' onmousemove='mouseMove(event);'></div>");
	document.write("<div class='UIbar' "+(document.all?"":"style='width:634px;'")+" onmouseover='showUI(selected);'><div id='uibar' class='UIBarInner'></div></div>");
	uibar = document.getElementById('uibar');
	document.write("<div style='position:absolute; top:0px; left:0px;' id='creditsPane'></div><table class='gameMenu' id='gameMenu' style='visibility:hidden;'><tr><td valign=middle align=center><div class='msgbox' id='menuBox'></div></td></tr></table>");
	creditsPane = document.getElementById('creditsPane');
	gameMenu = document.getElementById('gameMenu');
	menuBox = document.getElementById('menuBox');
	document.write("<table class='blackout' id='msg_div' style='visibility:hidden;'><tr><td id='msg_align' valign=middle align=center><table class='msgbox'><tr><td class='sponsorsprite' id='sponsor_sprite'></td><td align=center id='msg_text'></td></tr></table></tr></table>");
	sponsor_sprite = document.getElementById('sponsor_sprite');
	sponsor_sprite.frame = 0; sponsor_sprite.facing = 0; sponsor_sprite.animfunc=1; sponsor_sprite.framems = 200; sponsor_sprite.width=64; sponsor_sprite.height=64; sponsor_sprite.setFrame = function(f){setEventFrame(this, f);};
	addAnimElem(sponsor_sprite);
	msg_div = document.getElementById('msg_div');
	msg_align = document.getElementById('msg_align');
	msg_text = document.getElementById('msg_text');
	document.write('</div>');
	gameMenu.style.backgroundImage = "url('"+TITLE_IMG+"')";
	var mapName = window.location.href;
	var index = mapName.indexOf('map=');
	if(index == -1){
		showTitle();
	} else {
		var end = mapName.indexOf('&', index);
		if(end == -1) end = mapName.length;
		loadMap(mapName.substring(index+4, end));
	}
}
