var nlayers = 7;

var gameWindow, cursor, uibar, tileimg, tilecursor, tilemask, tileblock, worldName, eventEdit;
var mouse_down, mouse_left, mouse_top;
var world_mouse_down;
var cur_layer = 0;
var tilechanged = false, issaved = false;

var undoHistory = new Array(), undoLayer = new Array();
var undoAt = -1, redoAt = 0, undoMax = 12;

var textareafocused = false, blockid = 0;

if(document.layers){
	document.captureEvents(Event.KEYPRESS);
	document.captureEvents(Event.KEYDOWN);
	document.captureEvents(Event.KEYUP);
	document.captureEvents(Event.MOUSEMOVE);
	document.captureEvents(Event.MOUSEUP);
}
document.onkeypress = doKeyPress;
document.onkeydown = doKeyDown;
document.onkeyup = doKeyUp;
document.onmousemove = clearSelection;
document.onmouseup = clearSelection;

var tileanims = [false, false, false, false, false, false, false, false];

function loadTiles(){
	for(var layer=0; layer<nlayers; layer++){
		document.write("<div id='l"+layer+"' class=''>");
		for(var y=worldY-1; y>=0; y--)
			for(var x=0; x<worldX; x++)
				document.write("<div id='l"+layer+"t"+y+"l"+x+"' class='"+((layer == nlayers-1)?"":"tile tilemap")+"' style='"+((layer==0)?"":"background-position: 32px 32px; ")+"bottom:"+(y*TILE_SIZE)+"px; left:"+(x*TILE_SIZE)+"px;'></div>");
		document.write("</div>");
	}
}
function loadWorldBuilder(){
	document.write("<b>Map Name:</b><input type='text' size=30 id='worldName' onfocus='textareafocused=true;' onblur='textareafocused=false;' value='Untitled'>");
	document.write("<div style='position:relative; top:0px; left:0px;'>");
	document.write("<iframe class='viewWindow' style='height:480px; top:32px;' id='leftView' src='viewer.html?right' frameborder=0></iframe>");
	document.write("<iframe class='viewWindow' style='width:640px; left:32px;' id='topView' src='viewer.html?bottom' frameborder=0></iframe>");
	document.write("<iframe class='viewWindow' style='height:480px; top:32px; left:672px;' id='rightView' src='viewer.html?left' frameborder=0></iframe>");
	document.write("<iframe class='viewWindow' style='width:640px; left:32px; top:512px;' id='bottomView' src='viewer.html?top' frameborder=0></iframe>");
	document.write("</div><div style='position:relative; top:32px; left:32px;'><div id='gameWindow' class='gameWindow'>");
	worldName = document.getElementById('worldName');
	gameWindow = document.getElementById('gameWindow');
	loadTiles();
	document.write("<div id='cursor' class='cursor' style='width:32px; height:32px; visibility:hidden;'></div>");
	cursor = document.getElementById('cursor');
	document.write('</div>');
	if(document.all) document.write("<div class='mouseMask' ondblclick='editEvent();' onmousedown='worldMouseDown();' onmouseup='worldMouseUp();' onmouseout='worldMouseUp();' onmousemove='mouseMove();'></div>");
	else document.write("<div class='mouseMask' ondblclick='editEvent();' onmousedown='worldMouseDown(event);' onmouseup='worldMouseUp();' onmouseout='worldMouseUp();' onmousemove='mouseMove(event);'></div>");
	document.write("<div class='mouseMask dialog' style='visibility:hidden; top:-32px; left:-32px; width:704px; height:544px;' id='eventEdit'>");
	writeEventEditDialog();
	document.write("</div>");
	eventEdit = document.getElementById('eventEdit');
	document.write("<div class='msgbox' style='padding:0px; overflow: auto; position:absolute; top:-32px; left: 672px; width: 280px; height: 539px;'>");
	document.write("<div style='height:32px;'>");
	document.write("<div class='tile n0' style='left:0px;'></div>");
	document.write("<div class='tile n1' style='left:32px;'></div>");
	document.write("<div class='tile n2' style='left:64px;'></div>");
	document.write("<div class='tile n3' style='left:96px;'></div>");
	document.write("<div class='tile n4' style='left:128px;'></div>");
	document.write("<div class='tile n5' style='left:160px;'></div>");
	document.write("<div class='tile n6' style='left:192px;'></div>");
	document.write("<div class='tile n7' style='left:224px;'></div>");
	document.write("</div><div id='tileimg' class='tilemap'></div>");
	tileimg = document.getElementById('tileimg');
	document.write("<div id='tileblock' style='visibility:hidden; position:absolute; top:0px; left:0px;'></div>");
	tileblock = document.getElementById('tileblock');
	document.write("<div id='tilecursor' class='cursor' style='width:"+TILE_SIZE+"px; height:"+TILE_SIZE+"px; top:0px; left:0px;'></div>");
	tilecursor = document.getElementById('tilecursor');
	if(document.all) document.write("<div id='tilemask' style='position:absolute; top:0px; left:0px;' onmousedown='mouseDown();' onmouseup='mouse_down=false;' onmouseout='mouse_down=false;' onmousemove='dragTile();'></div>");
	else document.write("<div id='tilemask' style='position:absolute; top:0px; left:0px;' onmousedown='mouseDown(event);' onmouseup='mouse_down=false;' onmouseout='mouse_down=false;' onmousemove='dragTile(event);'></div>");
	tilemask = document.getElementById('tilemask');
	document.write('</div>');
	document.write("<div class='UIbar' style='height:50px; left:-32px; top:512px; width:984px;'><table cellpadding=2 cellspacing=0 height=100%><tr><td valign=middle align=center><div class='UIBarInner' style='width:697px; height:100%;'>");
	document.write("Tileset:&nbsp;&nbsp;"); TilesetSelector();
	document.write("&nbsp;&nbsp;&nbsp;&nbsp;Select Layer:");
	for(var layer=0; layer<nlayers; layer++){
		document.write("&nbsp;<input type='radio' name='layer' onclick='setLayer("+layer+");' id='layerrad"+layer+"'><div style='display:inline;' onclick='setLayer("+layer+");'>&nbsp;"+((layer == nlayers-1)?"Event":layer+1)+"</div>");
	}
	document.write("<br><input type='checkbox' id='onlylayer' onclick='toggleOnlyLayer();'><div style='display:inline;' onclick='toggleOnlyLayer();' id='onlyLayerText'>&nbsp;Show All Layers</div>");
	document.write("&nbsp;&nbsp;&nbsp;&nbsp;Brush:&nbsp;&nbsp;<div style='display:inline; text-decoration: underline;' onclick='toggleBrush();' id='brushLayer'>Normal Brush</div>");
	document.write("&nbsp;&nbsp;&nbsp;&nbsp;AutoTile:&nbsp;&nbsp;"); AutotileSelector();
	document.write("</div></td><td style='border-left:3px ridge #cccccc; padding-left:3px;' valign=middle align=center><div id='blockbrushes' style='width:274px; padding-left:23px; visibility:hidden;'>");
	for(var i=0; i<blocktypes; i++) document.write("<div class='"+getClassName(i)+"' style='float:left; margin-right:2px; position:relative; border:2px outset #cccccc;' onclick='selectBlockType(this, "+i+")'></div>");
	document.write("</div></td></tr></table></div>");
	document.write("<div style='position:absolute; top:582px; left:0px;'><b>World File:&nbsp;&nbsp;&nbsp;&nbsp;<a href='javascript:saveFile();'>(save)</a>&nbsp;&nbsp;&nbsp;&nbsp;<a href='javascript:saveTileset();'>(save tileset)</a>");
	document.write("&nbsp;&nbsp;&nbsp;&nbsp;<a href='javascript:loadFile();'>(load)</a>&nbsp;&nbsp;&nbsp;&nbsp;<a href='javascript:sendWorld();'>(send)</a>&nbsp;&nbsp;&nbsp;&nbsp;<a href='javascript:viewWorld();'>(view)</a>&nbsp;&nbsp;&nbsp;&nbsp;<a href='javascript:viewBlocking();'>(view blocking)</a></b><br>");
	document.write("<textarea id='worldfile' rows=8 cols=80 onfocus='textareafocused=true;' onblur='textareafocused=false;'></textarea>");
	document.write('</div>');
	if(document.all) setTimeout("setLayer(cur_layer)", 100);
	else setLayer(cur_layer);
	var autotilesel = document.getElementById('autotilesel');
	for(var n=0; n<8; n++){
		getStyleClass('n'+n).style.backgroundImage = "url('images/Autotiles/"+autotilesel[Math.min(n, autotilesel.length-1)].value+"')";
		var img = new Image();
		img.onload = function(){
			var url = this.src;
			url = unescape(url.substring(url.lastIndexOf('/')+1, url.lastIndexOf(".")+4));
			var id = selectIndex(autotilesel, url);
			if(this.width == 384) tileanims[id] = true; else tileanims[id] = false;
			};
		img.src = 'images/Autotiles/'+autotilesel[Math.min(n, autotilesel.length-1)].value;
	}
	toggleOnlyLayer();
	toggleBrush();
	setTileset();
	autoTileSel();
}

function setTileset(){setImage(document.getElementById('tiletext').value);}

var show_only_layer = true, rectangleBrush = true, dragBrush = true, dragging = false, dragLayer, dragLeft, dragBottom;

function toggleOnlyLayer(){
	show_only_layer = !show_only_layer;
	document.getElementById('onlylayer').checked = show_only_layer;
	if(show_only_layer){
		showOnlyLayer(cur_layer);
		document.getElementById('onlyLayerText').innerHTML = '&nbsp;Show Only Layer';
	} else{showAllLayers(); document.getElementById('onlyLayerText').innerHTML = '&nbsp;Show All Layers';}
}

function toggleBrush(){
	if(dragging) return;
	if(!rectangleBrush){rectangleBrush = true; dragBrush = false; document.getElementById('brushLayer').innerHTML = '&nbsp;Rectangle Brush';}
	else if(dragBrush){rectangleBrush = false; dragBrush = false; document.getElementById('brushLayer').innerHTML = '&nbsp;Normal Brush';}
	else {
		rectangleBrush = true; dragBrush = true; document.getElementById('brushLayer').innerHTML = '&nbsp;Drag Brush';
		cursor.style.width = '32px';
		cursor.style.height = '32px';
		return;
	}
	cursor.style.width = tilecursor.style.width;
	cursor.style.height = tilecursor.style.height;
}

function showAllLayers(){
	for(var l=0; l<nlayers; l++){
		var obj = document.getElementById('l'+l);
		obj.style.visibility = 'visible';
		obj.className = '';
	}
}

function setLayer(layer, hist){
	if(layer == cur_layer && undoAt != -1) return;
	cur_layer = layer;
	document.getElementById('layerrad'+cur_layer).checked = true;
	if(show_only_layer) showOnlyLayer(cur_layer);
	if(!hist) storeHistory();
	tileblock.style.visibility = (layer == nlayers-1)?'visible':'hidden';
	if(layer == nlayers-1){
		tilecursor.style.width = '32px';
		tilecursor.style.height = '32px';
		cursor.style.width = '32px';
		cursor.style.height = '32px';
		document.getElementById('blockbrushes').style.visibility = 'visible';
	} else document.getElementById('blockbrushes').style.visibility = 'hidden';
	oldX = -1; oldY = -1;
}

function showOnlyLayer(layer){
	document.getElementById('l'+layer).className = 'blackout';
	for(var l=0; l<=layer; l++)
		document.getElementById('l'+l).style.visibility = 'visible';
	for(var l=layer+1; l<nlayers; l++)
		document.getElementById('l'+l).style.visibility = 'hidden';
}

var jimage, img_ondone;
function setImage(img_src, ondone){
	jimage = new Image();
	img_ondone = ondone;
	jimage.onload = loadImage;
	jimage.src = 'images/Tilesets/'+img_src;
	document.getElementById('tiletext').value = img_src;
}

function loadImage(){
	tileimg.style.width = jimage.width+'px';
	tileimg.style.height = jimage.height+'px';
	tilemask.style.width = jimage.width+'px';
	tilemask.style.height = (jimage.height+32)+'px';
	tileblock.style.width = jimage.width+'px';
	tileblock.style.height = (jimage.height+32)+'px';
	getStyleClass('tilemap').style.backgroundImage = "url('"+jimage.src+"')";
	getStyleClass('tilemap').style.backgroundRepeat = 'no-repeat';
	var text = '';
	for(var y=0; y<=jimage.height*INV_TILE_SIZE; y++)
		for(var x=0; x<jimage.width*INV_TILE_SIZE; x++){
			text += "<div class='inherit' id='tbt"+y+"l"+x+"' style='top:"+(y*TILE_SIZE)+"px; left:"+(x*TILE_SIZE)+"px'></div>";
		}
	tileblock.innerHTML = text;
	if(img_ondone) img_ondone();
}

function getMouseCoords(e){
	var x, y;
	if(!e){
		x = window.event.offsetX;
		y = window.event.offsetY;
	} else {
		x = e.layerX;
		y = e.layerY;
	}
	return [x, 480-y];
}

function storeHistory(){
	issaved = false;
	if(undoAt == undoMax){
		undoHistory.shift();
		undoLayer.shift();
		undoAt--;
	}
	undoAt++; redoAt = undoAt;
	var ar = new Array();
	undoLayer[undoAt] = cur_layer;
	for(var y=0; y<worldY; y++)
		for(var x=0; x < worldX; x++){
			var obj = document.getElementById("l"+cur_layer+"t"+y+"l"+x);
			if(cur_layer == nlayers-1) ar[y*worldX+x] = eval(eventArray(obj));
			else ar[y*worldX+x] = [obj.style.backgroundPosition, obj.className];
		}
	undoHistory[undoAt] = ar;
}

var htmlreqobj;
function loadReqObj(){
	try{
		if(window.XMLHttpRequest)
			htmlreqobj = new XMLHttpRequest();
		else if(window.ActiveXObject)
			htmlreqobj = new ActiveXObject("Microsoft.XMLHTTP");
		if(!htmlreqobj) alert("Unable to connect to server.");
	}catch(e){alert("Unable to connect to server.");}
}

function getInt(str){var i = parseInt(str); return (i)?i:0;}
function getFloat(str){var f=parseFloat(str); return (f)?f:0;}

var viewWindow = null;
function viewWorld(){
	if(viewWindow == null || viewWindow.closed) viewWindow = window.open("index.html?map="+worldName.value);
	else viewWindow.location.href = "index.html?map="+worldName.value;
}

function viewBlocking(){
	if(viewWindow == null || viewWindow.closed) viewWindow = window.open("viewer.html?map="+worldName.value+"&blocking");
	else viewWindow.location.href = "viewer.html?map="+worldName.value+"&blocking";
}

function getBPosAr(bpos){
	bpos = bpos.split(" ");
	if(bpos.length != 2) return "0,0";
	return parseInt(bpos[0])+','+parseInt(bpos[1]);
}

function getClassIdx(name){
	if(name == 'tile tilemap') return -1;
	var s = name.substring(0, 11);
	if(s == 'auto tile n') return parseInt(name.substring(11, 12));
	if(s == 'autoInner n') return 8+parseInt(name.substring(11, 12));
	return -1;
}

function sendWorld(){
	var params = "tileset="+document.getElementById('tiletext').value+"&worldName="+worldName.value.toLowerCase()+"&autotiles=[";
	for(var n=0; n<8; n++){
		if(n != 0) params += ',';
		var url = getStyleClass('n'+n).style.backgroundImage;
		url = url.substring(url.lastIndexOf('/')+1, url.lastIndexOf(".")+4);
		params += "'"+url+"'";
	}
	params += "]&anims=[";
	for(var n=0; n<8; n++){
			if(n!=0) params += ",";
			params += tileanims[n];
	}
	params += "]&tiles=[";
	var first = true;
	var blockers = new Array(worldY*worldX);
	for(var l=0; l<nlayers; l++){
		if(l == nlayers-1){
			first = true;
			params +="]&events=[";
		}
		for(var y=0; y<worldY; y++)
			for(var x=0; x < worldX; x++){
				var obj = document.getElementById("l"+l+"t"+y+"l"+x);
				if(l == nlayers-1){
					if(obj.className=='event'){
						if(first) first = false; else params += ',';
						var obottom = getInt(obj.style.bottom), oleft = getInt(obj.style.left);
						params += "["+eventArray(obj)+", "+obottom+","+oleft+"]";
					}
				} else {
					var ar = obj.style.backgroundPosition.split(" ");
					var bx = getInt(ar[0]), by = getInt(ar[1]);
					var anim = -1; var t = obj.className;
					if(t.charAt(t.length-2) == 'n'){anim = parseInt(t.charAt(t.length-1)); if(isNaN(anim) | (anim < 0) | (anim >= 8)) anim = -1;}
					var blocker = document.getElementById("tbt"+((anim==-1)?(-by*INV_TILE_SIZE+1):0)+"l"+((anim==-1)?(-bx*INV_TILE_SIZE):anim));
					if(l == 0) blockers[y*worldX+x] = '0';
					var name = (blocker)?blocker.className:'';
					if(isBlankTile(name)) continue;
					if(blocker && !isInherit(name)) blockers[y*worldX+x] = isBlocker(name)?'1':'0';
					var numChild = obj.childNodes.length;
					var obottom = getInt(obj.style.bottom), oleft = getInt(obj.style.left);
					if(bx <= 0 && by <= 0){
						if(first) first = false; else params += ',';
						params += "["+getBPosAr(obj.style.backgroundPosition)+","+getClassIdx(obj.className)+","+obottom+","+oleft+","+getLayerNum(name)+"]";
					}
					for(var i=0; i<numChild; i++){
						var c = obj.childNodes[i];
						if(first) first = false; else params += ',';
						var layerval = 0;
						params += "["+getBPosAr(c.style.backgroundPosition)+","+getClassIdx(c.className)+","+(obottom+getInt(c.style.bottom))+","+(oleft+getInt(c.style.left))+","+getLayerNum(name)+"]";
					}
				}
			}
	}
	params += "]&blockers=[";
	for(var i=0; i<worldY*worldX; i++){if(i != 0) params += ","; params += blockers[i];}
	params += "]";
	loadReqObj();
	htmlreqobj.open("POST", "maploader.php", false);
	htmlreqobj.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	htmlreqobj.setRequestHeader("Content-length", params.length);
	htmlreqobj.setRequestHeader("Connection", "close");
	htmlreqobj.send(params);
	if(htmlreqobj.readyState == 4 && htmlreqobj.status == 200 && htmlreqobj.responseText == '1'){
		document.getElementById('worldfile').value = "World successfully sent to server.";
	}
	else document.getElementById('worldfile').value = "Unable to send World to server: "+htmlreqobj.responseText;
}

function loadFile(){
	if(confirm("Are you sure you wish to load the world file? All current changes will be lost.")){
		eventCANCEL();
		var tileset = false, autotile = false, map = false, blockers = false;
		eval(document.getElementById('worldfile').value);
		if(!tileset){alert('Bad World File.'); return;}
		var setBlockers = function(){
			if(blockers){
				var text = '';
				for(var y=0; y<blockers.length; y++){
					var ar = blockers[y];
					for(var x=0; x<ar.length; x++){
						text += "<div class='"+getClassName(ar[x])+"' id='tbt"+y+"l"+x+"' style='top:"+(y*TILE_SIZE)+"px; left:"+(x*TILE_SIZE)+"px'></div>";
					}
				}
				tileblock.innerHTML = text;
			}
		};
		setImage(tileset, setBlockers);
		if(map){
			for(var l=0; l<map.length; l++){
				var layer = map[l];
				for(var y=0; y<worldY; y++)
					for(var x=0; x < worldX; x++){
						var ar = layer[y*worldX+x];
						var obj = document.getElementById("l"+l+"t"+y+"l"+x);
						if(l == nlayers-1){obj.style.backgroundPosition = "0px 0px"; obj.className = ''; obj.setAttribute('tileanim', '0'); setEvent(obj, ar);}
						else {obj.style.backgroundPosition = ar[0]; obj.className = ar[1];}
					}
			}
		}
		if(autotile){
			for(var n=0; n<8; n++){
				getStyleClass('n'+n).style.backgroundImage = "url('images/Autotiles/"+autotile[n]+"')";
			}
		}
		for(var l=0; l<nlayers; l++){tilechanged = true; autoTile(l, 0, 0, worldX, worldY);}
		undoHistory = new Array(); undoLayer = new Array();
		undoAt = -1; redoAt = 0;
		setLayer(0);		
	}
}

function tilesetText(){
	var text = "tileset='"+document.getElementById('tiletext').value+"';";
	text += "autotile = [";
	for(var n=0; n<8; n++){
		var url = getStyleClass('n'+n).style.backgroundImage;
		url = url.substring(url.lastIndexOf('/')+1, url.lastIndexOf(".")+4);
		if(n!=0) text += ",";
		text += "'"+url+"'";
	}
	text += "];"
	text += "tileanims = [";
	for(var n=0; n<8; n++){
		if(n!=0) text += ",";
		text += tileanims[n];
	}
	text += "];"
	text += "blockers=[";
	var h = parseInt(tileimg.style.height)*INV_TILE_SIZE, w = parseInt(tileimg.style.width)*INV_TILE_SIZE;
	for(var y=0; y<=h; y++){
		if(y != 0) text += ",";
		text += "[";
		for(var x=0; x<w; x++){
			var obj = document.getElementById("tbt"+(y)+"l"+(x));
			if(x != 0) text += ",";
			text += getClassNum(obj.className);
		}
		text += "]";
	}
	text += "];";
	return text;
}

function saveTileset(){
	document.getElementById('worldfile').value = tilesetText();
	document.getElementById('worldfile').focus();
	document.getElementById('worldfile').select();
}

function saveFile(){
	issaved = true;
	var text = "worldName.value='"+worldName.value+"';";
	text += "document.getElementById('leftView').src='"+document.getElementById('leftView').contentWindow.location.href+"';";
	text += "document.getElementById('rightView').src='"+document.getElementById('rightView').contentWindow.location.href+"';";
	text += "document.getElementById('topView').src='"+document.getElementById('topView').contentWindow.location.href+"';";
	text += "document.getElementById('bottomView').src='"+document.getElementById('bottomView').contentWindow.location.href+"';";
	text += tilesetText();
	text += "map = [";
	for(var l=0; l<nlayers; l++){
		if(l != 0) text += ",";
		text += "[";
		for(var y=0; y<worldY; y++)
			for(var x=0; x < worldX; x++){
				var obj = document.getElementById("l"+l+"t"+y+"l"+x);
				if(y+x != 0 ) text += ",";
				text += (l == nlayers-1)?eventArray(obj):"['"+obj.style.backgroundPosition+"','"+obj.className+"']";
			}
		text += "]";
	}
	text += "];"
	document.getElementById('worldfile').value = text;
	document.getElementById('worldfile').focus();
	document.getElementById('worldfile').select();
}

var worldChanged = false;

var world_left, world_bottom;

function clearSelection(){
	if(textareafocused) return;
	if(window.getSelection) window.getSelection().removeAllRanges();
	if(document.selection) document.selection.empty();
}

function worldMouseUp(){
	if(!world_mouse_down) return;
	world_mouse_down=false;
	if(cur_layer == nlayers-1){
		var x = parseInt(cursor.style.left)*INV_TILE_SIZE, y = parseInt(cursor.style.bottom)*INV_TILE_SIZE;
		if((x != world_left) | (y != world_bottom)){
			var obj = document.getElementById("l"+cur_layer+"t"+world_bottom+"l"+world_left);
			setEvent(document.getElementById("l"+cur_layer+"t"+y+"l"+x), eval(eventArray(obj)));
			if(!shiftDown) deleteEvent(obj);
			storeHistory();
		}
		return;
	}
	if(rectangleBrush && worldChanged){
		var x = parseInt(cursor.style.left)*INV_TILE_SIZE, y = parseInt(cursor.style.bottom)*INV_TILE_SIZE;
		if(dragBrush){dragLeft = x; dragBottom = y; worldChanged = false; dragging = true; dragLayer = cur_layer; cursor.style.backgroundImage="url('images/drag-cursor.gif')"; return;}
		tilechanged = true;
		var maxx = x+parseInt(cursor.style.width)*INV_TILE_SIZE, maxy = y+parseInt(cursor.style.height)*INV_TILE_SIZE;
		for(var cy=y; cy<maxy; cy++)
			for(var cx=x; cx < maxx; cx++){
				var obj = document.getElementById("l"+cur_layer+"t"+cy+"l"+cx);
				if(obj){
					var twidth = parseInt(tilecursor.style.width), theight = parseInt(tilecursor.style.height);
					var ctop = parseInt(tilecursor.style.top)+(32*(maxy-cy-1))%theight;
					var cleft = parseInt(tilecursor.style.left)+(32*(cx-x))%twidth;
					if(ctop < 32){
						var n = (cleft*INV_TILE_SIZE);
						obj.className = 'auto tile n'+n;
						obj.style.backgroundPosition = '0px 0px';
						obj.innerHTML = '';
					}
					else{obj.className = 'tile tilemap'; obj.style.backgroundPosition = (-cleft)+' '+(-ctop+32); obj.innerHTML = '';}
				}
			}
		autoTile(cur_layer, Math.max(0, x-1), Math.max(0, y-1), Math.min(worldX, maxx+1), Math.min(worldY, maxy+1));
		cursor.style.width = tilecursor.style.width;
		cursor.style.height = tilecursor.style.height;
	}
	if(worldChanged) storeHistory();
	worldChanged = false;
}

function writeEventEditDialog(){
	document.write("<table border=0 cellpadding=0 cellspacing=0 width=100% height=100%><tr><td valign=middle align=center><table border=1 cellpadding=5 cellspacing=5 width=95% height=95%><tr height=8%>");
	document.write("<td colspan=2><b>Event Name:</b><input type=text size=30 id='eventname' onfocus='textareafocused=true;' onblur='textareafocused=false;'></td></tr><tr height=34%>");
	document.write("<td width=30% align=center><table><tr><td class='spriteViewer' valign=middle align=center><div class='spriteViewerInner' id='spriteViewer'></div></td></tr></table><b>Sprite:</b>");
	SpriteSelector();
	document.write("<br><b>View:</b><select onfocus='textareafocused=true;' onblur='textareafocused=false;' id='animSprite'><option value='0'>None</option><option value='1'>Walk Loop</option><option value='2'>Rotate Loop</option></select>");
	document.write("</td><td rowspan=2 width=70%><textarea id='eventScript' onfocus='textareafocused=true;' onblur='textareafocused=false;' style='width:100%; height:100%;'></textarea></td>");
	document.write("</tr><tr height=50%>");
	document.write("<td width=30% style='font-size:14px;'><b>Dir:</b>&nbsp;<input type='text' style='width:30px;' id='spriteDir' onfocus='textareafocused=true;' onblur='textareafocused=false;' onchange='changeSprite();' value='0'>");
	document.write("&nbsp;&nbsp;<b>Frame:</b>&nbsp;<input type='text' style='width:30px;' onfocus='textareafocused=true;' onblur='textareafocused=false;' onchange='changeSprite();' id='spriteFrame' value='0'>");
	document.write("<br><b>Hp:</b>&nbsp;<input type='text' style='width:45px;' id='eventhealth' onfocus='textareafocused=true;' onblur='textareafocused=false;' value='0'>");
	document.write("&nbsp;&nbsp;<b>Mp:</b>&nbsp;<input type='text' style='width:45px;' id='eventmana' onfocus='textareafocused=true;' onblur='textareafocused=false;' value='0'>");
	document.write("<br><b>Step size:</b>&nbsp;<input type='text' style='width:30px;' id='eventstepsize' onfocus='textareafocused=true;' onblur='textareafocused=false;' value='0.25'>");
	document.write("&nbsp;&nbsp;<b>ms:</b>&nbsp;<input type='text' style='width:30px;' id='eventms' onfocus='textareafocused=true;' onblur='textareafocused=false;' value='100'>");
	document.write("<br><b>Range:</b>&nbsp;<input type='text' style='width:25px;' id='eventrange' onfocus='textareafocused=true;' onblur='textareafocused=false;' value='0'>");
	document.write("&nbsp;&nbsp;<select onfocus='textareafocused=true;' onblur='textareafocused=false;' id='eventblock'><option value='0'>Ground P</option><option value='1'>Event P</option><option value='2'>On Top P</option><option value='3'>Ground B</option><option value='4'>Event B</option><option value='5'>On Top B</option></select>");
	document.write("<br><b>Anim:</b>&nbsp;<select onfocus='textareafocused=true;' onblur='textareafocused=false;' id='eventanim'><option value='0'>None</option><option value='1'>Walk Loop</option><option value='2'>Rotate Loop</option></select>");
	document.write("<br><b>Control:</b>&nbsp;<select onfocus='textareafocused=true;' onblur='textareafocused=false;' id='eventcontrol'><option value='0'>None Still</option><option value='1'>None Random</option><option value='2'>Enemy Still</option><option value='3'>Enemy Random</option><option value='4'>Player Still</option><option value='5'>Player Random</option></select>");
	document.write("<br><b>Named:</b>&nbsp;<input type='checkbox' id='eventshowname'>");
	document.write("</td></tr><tr height=8%><td colspan=2 align=center style='border:0px;'><input type='button' value='OK' onclick='eventOK();'>&nbsp;&nbsp;&nbsp;&nbsp;<input type='button' value='Cancel' onclick='eventCANCEL();'></td></tr>");
	document.write("</table></td></tr></table>");
}

function setSprite(img_src){
	if(img_src == 'none'){
		var viewer = document.getElementById('spriteViewer');
		viewer.style.width = Math.min(128, jimage.width*0.25)+'px';
		viewer.style.height = Math.min(128, jimage.height*0.25)+'px';
		viewer.style.backgroundImage = "";
		viewer.style.backgroundPosition = "0px 0px";
		document.getElementById('spriteDir').value = '0';
		document.getElementById('spriteFrame').value = '0';
	} else {
		jimage = new Image();
		jimage.onload = loadSprite;
		jimage.src = 'images/Characters/'+img_src;
	}
}

function loadSprite(){
	var viewer = document.getElementById('spriteViewer');
	viewer.style.width = Math.min(128, jimage.width*0.25)+'px';
	viewer.style.height = Math.min(128, jimage.height*0.25)+'px';
	viewer.style.backgroundImage = "url('"+jimage.src+"')";
	viewer.style.backgroundPosition = "0px 0px";
	changeSprite();
}

setTimeout('spriteViewerAnim()', 200);

function changeSprite(){
	var viewer = document.getElementById('spriteViewer');
	var f = document.getElementById('spriteFrame'), d = document.getElementById('spriteDir');
	var x = getInt(f.value)%4, y = getInt(d.value)%4;
	viewer.style.backgroundPosition = (-x*parseInt(viewer.style.width))+'px '+(-y*parseInt(viewer.style.height))+'px';
	f.value = x; d.value=y;
}

var doneAnim = true;

function spriteViewerAnim(){
	var animSprite = parseInt(document.getElementById('animSprite').value);
	if(eventEdit.style.visibility == 'visible'){
		if(animSprite != 0){
			doneAnim = false;
			var viewer = document.getElementById('spriteViewer');
			var ar = viewer.style.backgroundPosition.split(" ");
			if(animSprite == 2){
				var height = parseInt(viewer.style.height);
				var y = (-parseInt(ar[1])/height+1)%4;
				viewer.style.backgroundPosition = ar[0]+' '+(-y*height)+'px';
			} else {
				var width = parseInt(viewer.style.width);
				var x = (-parseInt(ar[0])/width+1)%4;
				viewer.style.backgroundPosition = (-x*width)+'px '+ar[1];
			}
		} else if(!doneAnim){changeSprite(); doneAnim=true;}
	}
	setTimeout('spriteViewerAnim()', 200);
}

function getAttr(obj, attr, def){
	var ret = obj.getAttribute(attr);
	return (ret)?ret:def;
}

function editEvent(){
	if(cur_layer != nlayers-1) return;
	var x = parseInt(cursor.style.left)*INV_TILE_SIZE, y = parseInt(cursor.style.bottom)*INV_TILE_SIZE;
	var obj = document.getElementById("l"+cur_layer+"t"+y+"l"+x);
	var sprite = getAttr(obj, 'sprite', 'none');
	document.getElementById('eventScript').value = unescapeStr(getAttr(obj, 'script', ''));
	document.getElementById('eventname').value = getAttr(obj, 'ename', 'Unnamed');
	document.getElementById('spriteDir').value = getAttr(obj, 'dir', '0');
	document.getElementById('spriteFrame').value = getAttr(obj, 'frame', '0');
	document.getElementById('eventhealth').value = getAttr(obj, 'health', '0');
	document.getElementById('eventmana').value = getAttr(obj, 'mana', '0');
	document.getElementById('eventstepsize').value = getAttr(obj, 'step', '0.25');
	document.getElementById('eventms').value = getAttr(obj, 'framems', '100');
	document.getElementById('eventrange').value = getAttr(obj, 'range', '0');
	selectValue(document.getElementById('eventblock'), getAttr(obj, 'block', '0'));
	selectValue(document.getElementById('eventanim'), getAttr(obj, 'anim', '0'));
	selectValue(document.getElementById('eventcontrol'), getAttr(obj, 'control', '0'));
	document.getElementById('eventshowname').checked = parseInt(getAttr(obj, 'named', '0')) == 1;
	setSprite(sprite);
	selectValue(document.getElementById('spritesel'), sprite);
	eventEdit.style.visibility = 'visible';
}

function eventCANCEL(){eventEdit.style.visibility = 'hidden';}

function eventOK(){
	var x = parseInt(cursor.style.left)*INV_TILE_SIZE, y = parseInt(cursor.style.bottom)*INV_TILE_SIZE;
	var obj = document.getElementById("l"+cur_layer+"t"+y+"l"+x);
	obj.className = 'event';
	var viewer = document.getElementById('spriteViewer');
	var url = document.getElementById('spritesel').value;
	obj.setAttribute('sprite', url);
	obj.setAttribute('script', escapeStr(document.getElementById('eventScript').value));
	obj.setAttribute('ename', document.getElementById('eventname').value);
	var width = getInt(viewer.style.width); obj.setAttribute('swidth', width);
	var height = getInt(viewer.style.height); obj.setAttribute('sheight', height);
	obj.setAttribute('dir', getInt(document.getElementById('spriteDir').value));
	obj.setAttribute('frame', getInt(document.getElementById('spriteFrame').value));
	obj.setAttribute('health', getInt(document.getElementById('eventhealth').value));
	obj.setAttribute('mana', getInt(document.getElementById('eventmana').value));
	obj.setAttribute('step', getFloat(document.getElementById('eventstepsize').value));
	obj.setAttribute('framems', getInt(document.getElementById('eventms').value));
	obj.setAttribute('range', getInt(document.getElementById('eventrange').value));
	obj.setAttribute('block', document.getElementById('eventblock').value);
	obj.setAttribute('anim', document.getElementById('eventanim').value);
	obj.setAttribute('control', document.getElementById('eventcontrol').value);
	obj.setAttribute('named', (document.getElementById('eventshowname').checked?'1':'0'));
	obj.innerHTML = "<div class='spriteViewerInner' style=\"position:absolute; top:"+(-(height-32))+"; left:"+(-(width-32)*0.5)+"; width:"+width+"px; height:"+height+"px; background-image:url('images/Characters/"+url+"'); background-position:"+viewer.style.backgroundPosition+";\"></div>";
	storeHistory();
	eventEdit.style.visibility = 'hidden';
}

function deleteEvent(obj){
	obj.className = '';
	obj.setAttribute('sprite', '');
	obj.setAttribute('script', '');
	obj.setAttribute('ename', '');
	obj.setAttribute('swidth', '');
	obj.setAttribute('sheight', '');
	obj.setAttribute('dir', '');
	obj.setAttribute('frame', '');
	obj.setAttribute('health', '');
	obj.setAttribute('mana', '');
	obj.setAttribute('step', '');
	obj.setAttribute('framems', '');
	obj.setAttribute('range', '');
	obj.setAttribute('block', '');
	obj.setAttribute('anim', '');
	obj.setAttribute('control', '');
	obj.setAttribute('named', '');
	obj.innerHTML = '';
}

function eventArray(obj){
	if(obj.className != 'event') return '0';
	return "['"+getAttr(obj, 'sprite', 'none')+"','"+getAttr(obj, 'ename', 'Unnamed')+"','"+getAttr(obj, 'script', '')+
	"',"+getAttr(obj, 'swidth', '32')+","+getAttr(obj, 'sheight', '32')+","+getAttr(obj, 'dir', '0')+","+getAttr(obj, 'frame', '0')+
	","+getAttr(obj, 'health', '0')+","+getAttr(obj, 'mana', '0')+","+getAttr(obj, 'step', '0.25')+","+getAttr(obj, 'framems', '100')+
	","+getAttr(obj, 'range', '0')+","+getAttr(obj, 'block', '0')+","+getAttr(obj, 'anim', '0')+","+getAttr(obj, 'control', '0')+
	","+getAttr(obj, 'named', '0')+"]";
	
}

function setEvent(obj, ar){
	if(ar == '0'){deleteEvent(obj); return;}
	obj.className = 'event';
	obj.setAttribute('sprite', ar[0]);
	obj.setAttribute('ename', ar[1]);
	obj.setAttribute('script', ar[2]);
	obj.setAttribute('swidth', ar[3]);
	obj.setAttribute('sheight', ar[4]);
	obj.setAttribute('dir', ar[5]);
	obj.setAttribute('frame', ar[6]);
	obj.setAttribute('health', ar[7]);
	obj.setAttribute('mana', ar[8]);
	obj.setAttribute('step', ar[9]);
	obj.setAttribute('framems', ar[10]);
	obj.setAttribute('range', ar[11]);
	obj.setAttribute('block', ar[12]);
	obj.setAttribute('anim', ar[13]);
	obj.setAttribute('control', ar[14]);
	obj.setAttribute('named', ar[15]);
	var bp = (-parseInt(ar[6])*parseInt(ar[3]))+'px '+(-parseInt(ar[5])*parseInt(ar[4]))+'px';
	obj.innerHTML = "<div class='spriteViewerInner' style=\"position:absolute; top:"+(-(parseInt(ar[4])-32))+"; left:"+(-(parseInt(ar[3])-32)*0.5)+"; width:"+ar[3]+"px; height:"+ar[4]+"px; background-image:url('images/Characters/"+ar[0]+"'); background-position:"+bp+";\"></div>";
}

function worldMouseDown(e){
	var c = getMouseCoords(e);
	world_mouse_down=true; worldChanged = false;
	if(cur_layer == nlayers-1){world_left = Math.floor(c[0]*INV_TILE_SIZE); world_bottom = (Math.floor(c[1]*INV_TILE_SIZE)); return;}
	world_left = Math.floor(c[0]*INV_TILE_SIZE)*TILE_SIZE; world_bottom = (Math.ceil(c[1]*INV_TILE_SIZE))*TILE_SIZE;
	if(dragging){
		var w = parseInt(cursor.style.width)*INV_TILE_SIZE, h = parseInt(cursor.style.height)*INV_TILE_SIZE;
		if(!shiftDown){
			dragging = false;
			cursor.style.backgroundImage="url('images/cursor.gif')";
			cursor.style.width = TILE_SIZE+'px';
			cursor.style.height = TILE_SIZE+'px';
		}
		world_mouse_down=false;
		var x = world_left*INV_TILE_SIZE, y = world_bottom*INV_TILE_SIZE-1;
		var ar = new Array(w*h);
		for(var cy=0; cy<h; cy++)
			for(var cx=0; cx < w; cx++){
				var obj = document.getElementById("l"+dragLayer+"t"+(dragBottom+cy)+"l"+(dragLeft+cx));
				ar[cy*w+cx] = [obj.className, obj.style.backgroundPosition];
				if(!shiftDown && obj){obj.className = 'tile tilemap'; obj.style.backgroundPosition = '32px 32px'; obj.innerHTML = '';}
			}
		if(!shiftDown){
			var tmp = cur_layer;
			cur_layer = dragLayer;
			storeHistory();
			cur_layer = tmp;
			tilechanged = true;
			autoTile(dragLayer, 0, 0, worldX, worldY);
		}
		for(var cy=0; cy<h; cy++)
			for(var cx=0; cx < w; cx++){
				var obj = document.getElementById("l"+cur_layer+"t"+(y+cy)+"l"+(x+cx));
				if(obj){obj.className = ar[cy*w+cx][0]; obj.style.backgroundPosition = ar[cy*w+cx][1]; obj.innerHTML = '';}
			}
		tilechanged = true;
		autoTile(cur_layer, 0, 0, worldX, worldY);
		storeHistory();
		return;
	}
	oldX = -1; oldY = -1;
	mouseMove(e);
}

var shiftDown = false, ctrlDown = false;

function doKeyDown(e){
	var code = e?e.which:window.event.keyCode;
	if(code == 16) shiftDown = true;
	if(code == 17) ctrlDown = true;
	if(textareafocused) return true;
	if(code == 46){
		var x = parseInt(cursor.style.left)*INV_TILE_SIZE, y = parseInt(cursor.style.bottom)*INV_TILE_SIZE;
		var obj = document.getElementById("l"+(nlayers-1)+"t"+y+"l"+x);
		deleteEvent(obj);
		storeHistory();
	}
	var ev = e?e:window.event;
	if(ctrlDown && (code == 90 || code == 122)) undoLast();
	if(ctrlDown && (code == 89 || code == 121)) redoLast();
	return false;
}

function doKeyUp(e){
	var code = e?e.which:window.event.keyCode;
	if(code == 16){
		shiftDown = false;
		if(dragging){
			dragging = false;
			cursor.style.backgroundImage="url('images/cursor.gif')";
			cursor.style.width = TILE_SIZE+'px';
			cursor.style.height = TILE_SIZE+'px';
		}
	}
	if(code == 17) ctrlDown = false;
	return textareafocused;
}

function doKeyPress(e){
	return textareafocused;
}

function getAutoNumber(layer, x, y, n){
	var obj = document.getElementById("l"+layer+"t"+y+"l"+x);
	if(obj) return obj.className.charAt(obj.className.length-1); else return n;
}

function isBorder(layer, x, y, n){
	for(var ty=y-1; ty<=y+1; ty++)
		for(var tx=x-1; tx<=x+1; tx++)
			if(getAutoNumber(layer, tx, ty, n) != n) return true;
	return false;
}

function processAnimTile(obj){
	for(var i=0; i<obj.childNodes.length; i++)
		addAnimElem(obj.childNodes[i]);
}

function getCorner(layer, x, y, n, dx, dy, tileanim){
	var bx = -32, by = -64, sy=16, sx=16;
	if(getAutoNumber(layer, x+dx, y, n) != n && getAutoNumber(layer, x, y+dy, n) != n){bx = 0; by = 0;}
	else if(getAutoNumber(layer, x+dx, y, n) != n && getAutoNumber(layer, x, y+dy, n) == n){bx = 0; by = -64; sx = 80;}
	else if(getAutoNumber(layer, x, y+dy, n) != n && getAutoNumber(layer, x+dx, y, n) == n){bx = -32; by = -32; sy = 80;}
	if(getAutoNumber(layer, x+dx, y+dy, n) != n && getAutoNumber(layer, x+dx, y, n) == n && getAutoNumber(layer, x, y+dy, n) == n){bx = -64; by = 0;}
	return "<div class='autoInner n"+n+"' "+((tileanim)?"tileanim='1'":"")+"style='background-position: "+((dx==-1)?bx:bx-sx)+"px "+((dy==1)?by:by-sy)+"px; left: "+((dx==-1)?0:16)+"; bottom: "+((dy==1)?16:0)+";'></div>";
}

function autoTile(layer, lx, ly, hx, hy){
	if(!tilechanged) return;
	tilechanged = false;
	if(layer == nlayers-1) return;
	for(var y=ly; y<hy; y++)
		for(var x=lx; x < hx; x++){
			var obj = document.getElementById("l"+layer+"t"+y+"l"+x);
			if(obj && obj.className.substring(0, 4) == 'auto'){
				var n = obj.className.charAt(obj.className.length-1);
				if(isBorder(layer, x, y, n)){
					var text = '';
					text += getCorner(layer, x, y, n, -1, 1, tileanims[n]);
					text += getCorner(layer, x, y, n, 1, 1, tileanims[n]);
					text += getCorner(layer, x, y, n, 1, -1, tileanims[n]);
					text += getCorner(layer, x, y, n, -1, -1, tileanims[n]);
					obj.className = 'auto tile n'+n; obj.innerHTML = text;
					obj.style.backgroundRepeat = 'repeat-x';
					obj.style.backgroundPosition = '32px 32px';
					processAnimTile(obj);
				}
				else{
					obj.className = 'auto tile n'+n; obj.style.backgroundPosition = '-32px -64px';
					obj.innerHTML = '';
					obj.setAttribute('tileanim', (tileanims[n])?'1':'0');
					addAnimElem(obj);
				}
			} else if(obj){
				obj.setAttribute('tileanim', '0');
				obj.innerHTML = '';
			}
		}
}

function redoLast(){
	if(undoAt == redoAt) return;
	undoAt++;
	var l = undoLayer[undoAt];
	var ar = undoHistory[undoAt];
	for(var y=0; y<worldY; y++)
		for(var x=0; x < worldX; x++){
			var obj = document.getElementById("l"+l+"t"+y+"l"+x);
			var tmp = ar[y*worldX+x];
			if(l == nlayers-1){
				obj.style.backgroundPosition = "0px 0px";
				obj.className = '';
				setEvent(obj, tmp);
			} else {
				obj.style.backgroundPosition = tmp[0];
				obj.className = tmp[1];
				obj.innerHTML = '';
			}
		}
	tilechanged = true;
	autoTile(l, 0, 0, worldX, worldY);
	setLayer(l, true);
}

function undoLast(){
	if(undoAt == 0) return;
	undoAt--;
	var l = undoLayer[undoAt];
	var ar = undoHistory[undoAt];
	for(var y=0; y<worldY; y++)
		for(var x=0; x < worldX; x++){
			var obj = document.getElementById("l"+l+"t"+y+"l"+x);
			var tmp = ar[y*worldX+x];
			if(l == nlayers-1){
				obj.style.backgroundPosition = "0px 0px";
				obj.className = '';
				setEvent(obj, tmp);
			} else {
				obj.style.backgroundPosition = tmp[0];
				obj.className = tmp[1];
				obj.innerHTML = '';
			}
		}
	tilechanged = true;
	autoTile(l, 0, 0, worldX, worldY);
	setLayer(l, true);
}

var oldX = -1, oldY = -1;

function mouseMove(e){
	var c = getMouseCoords(e);
	cursor.style.visibility = 'visible';
	cursor.style.bottom = Math.floor(c[1]*INV_TILE_SIZE)*TILE_SIZE+'px';
	cursor.style.left = Math.floor(c[0]*INV_TILE_SIZE)*TILE_SIZE+'px';
	if(cur_layer == nlayers-1) return;
	if(rectangleBrush & dragBrush & !dragging){
		cursor.style.width = TILE_SIZE+'px';
		cursor.style.height = TILE_SIZE+'px';
	}
	var x = Math.floor(c[0]*INV_TILE_SIZE), y = Math.floor(c[1]*INV_TILE_SIZE);
	if(rectangleBrush && world_mouse_down){
		worldChanged = true;
		x = Math.floor(c[0]*INV_TILE_SIZE)*TILE_SIZE; y = (Math.ceil(c[1]*INV_TILE_SIZE))*TILE_SIZE;
		var cx = world_left, cy = world_bottom;
		if(cx > x){var tmp=cx; cx = x; x = tmp;}
		if(cy > y){var tmp=cy; cy = y; y = tmp;}
		cursor.style.left = cx+'px';
		cursor.style.bottom = (cy-TILE_SIZE)+'px';
		cursor.style.width = x+TILE_SIZE-cx+'px';
		cursor.style.height = y+TILE_SIZE-cy+'px';
		return;
	}
	if(!world_mouse_down || (x == oldX && y == oldY)) return;
	oldX = x; oldY = y;
	tilechanged = true;
	var maxx = x+parseInt(cursor.style.width)*INV_TILE_SIZE, maxy = y+parseInt(cursor.style.height)*INV_TILE_SIZE;
	for(var cy=y; cy<maxy; cy++)
		for(var cx=x; cx < maxx; cx++){
			var obj = document.getElementById("l"+cur_layer+"t"+cy+"l"+cx);
			if(obj){
				var ctop = parseInt(tilecursor.style.top)+32*(maxy-cy-1);
				var cleft = parseInt(tilecursor.style.left)+32*(cx-x);
				if(ctop < 32){
					var n = (cleft*INV_TILE_SIZE);
					obj.className = 'auto tile n'+n;
					obj.style.backgroundPosition = '0px 0px';
					obj.innerHTML = '';
				}
				else{obj.className = 'tile tilemap'; obj.style.backgroundPosition = (-cleft)+' '+(-ctop+32); obj.innerHTML = '';}
			}
		}
	worldChanged = true;
	autoTile(cur_layer, Math.max(0, x-1), Math.max(0, y-1), Math.min(worldX, maxx+1), Math.min(worldY, maxy+1));
}

function selAutoTile(){
	if((parseInt(cursor.style.width) != 32) | (parseInt(cursor.style.width)!= 32)) return -1;
	var ctop = parseInt(tilecursor.style.top);
	if(ctop >= 32) return -1;
	return parseInt(tilecursor.style.left)*INV_TILE_SIZE;
}

function setAutoTile(img_src){
	if(selAutoTile() == -1) return;
	jimage = new Image();
	jimage.onload = loadAutoTile;
	jimage.src = 'images/Autotiles/'+img_src;
}

function loadAutoTile(){
	var n = selAutoTile()
	if(n == -1) return;
	if(jimage.width == 384) tileanims[n] = true; else tileanims[n] = false;
	getStyleClass('n'+n).style.backgroundImage = "url('"+jimage.src+"')";
	for(var l=0; l<nlayers; l++){tilechanged = true; autoTile(l, 0, 0, worldX, worldY);}
}

function selectValue(sel, val){
	for(var i=0; i<sel.length; i++)
		if(sel[i].value == val){
			sel.selectedIndex = i;
			break;
		}
}

function selectIndex(sel, val){
	for(var i=0; i<sel.length; i++)
		if(sel[i].value == val) return i;
	return -1;
}

function autoTileSel(){
	var n = selAutoTile();
	var autotilesel = document.getElementById('autotilesel');
	if(n != -1){
		var url = getStyleClass('n'+n).style.backgroundImage;
		url = unescape(url.substring(url.lastIndexOf('/')+1, url.lastIndexOf(".")+4));
		autotilesel.disabled = false;
		if(autotilesel.value == url) return;
		selectValue(autotilesel, url);
		
	} else autotilesel.disabled = true;
}

function isInherit(name){return name == 'inherit' || name.substring(0,5) == 'ontop';}
function isBlocker(name){return name == 'blocker' || name == 'groundblock';}
function getLayerNum(name){return (name.substring(0,5) == 'ontop')?(parseInt(name.charAt(7))+1):((name == 'groundpass' || name == 'groundblock')?0:1);}
function isBlankTile(name){return name == 'blanktile';}

function getClassNum(name){
	if(name == 'inherit') return 0;
	else if(name == 'blocker') return 1;
	else if(name.substring(0,5) == 'ontop'){var i = parseInt(name.charAt(7)); return (i == 1)?2:(4+i);}
	else if(name == 'groundpass') return 3;
	else if(name == 'groundblock') return 4;
	else if(name == 'blanktile') return 5;
	return 0;
}

var blocktypes = 6;

function getClassName(num){
	if(num == 0) return 'inherit';
	else if(num == 1) return 'blocker';
	else if(num == 2) return 'ontop l1';
	else if(num == 3) return 'groundpass';
	else if(num == 4) return 'groundblock';
	else if(num == 5) return 'blanktile';
	return 'ontop l'+(num-4);
}

var cur_sel_block = null;

function selectBlockType(obj, id){
	if(cur_sel_block != null){cur_sel_block.style.border = '2px outset #cccccc';}
	obj.style.border = '2px inset #cccccc';
	cur_sel_block = obj;
	blockid = id;
}

var oldTileX, oldTileY;
function flipBlock(x, y){
	var obj = document.getElementById("tbt"+(y*INV_TILE_SIZE)+"l"+(x*INV_TILE_SIZE));
	if(!obj) return;
	var l = getLayerNum(obj.className);
	if(l >= 2 && blockid == 2) obj.className = 'ontop l'+((l>=6)?1:l);
	else obj.className = getClassName(blockid);
}

function mouseDown(e){
	mouse_down = true;
	var c = getMouseCoords(e);
	mouse_top = (worldY-Math.ceil(c[1]*INV_TILE_SIZE))*TILE_SIZE;
	mouse_left = Math.floor(c[0]*INV_TILE_SIZE)*TILE_SIZE;
	oldTileX = mouse_left;
	oldTileY = mouse_top;
	tilecursor.style.top = mouse_top+'px';
	tilecursor.style.left = mouse_left+'px';
	tilecursor.style.width = TILE_SIZE+'px';
	tilecursor.style.height = TILE_SIZE+'px';
	cursor.style.width = TILE_SIZE+'px';
	cursor.style.height = TILE_SIZE+'px';
	autoTileSel();
	if(cur_layer == nlayers-1) flipBlock(mouse_left, mouse_top);
}

function dragTile(e){
	autoTileSel();
	if(!mouse_down) return;
	var c = getMouseCoords(e);
	var x = Math.floor(c[0]*INV_TILE_SIZE)*TILE_SIZE, y = (worldY-Math.ceil(c[1]*INV_TILE_SIZE))*TILE_SIZE;
	if((oldTileX == x) & (oldTileY == y)) return;
	oldTileX = x; oldTileY = y;
	if(cur_layer == nlayers-1){flipBlock(x, y); return;}
	var cx = mouse_left, cy = mouse_top;
	if(cx > x){var tmp=cx; cx = x; x = tmp;}
	if(cy > y){var tmp=cy; cy = y; y = tmp;}
	tilecursor.style.left = cx+'px';
	tilecursor.style.top = cy+'px';
	tilecursor.style.width = x+TILE_SIZE-cx+'px';
	tilecursor.style.height = y+TILE_SIZE-cy+'px';
	cursor.style.width = x+TILE_SIZE-cx+'px';
	cursor.style.height = y+TILE_SIZE-cy+'px';
}
